<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Application\ApplicationProgram;
use Rc\Domain\Repository\Application\ApplicationProgramRepository;
use Rc\Domain\Repository\MongoRepository;

class ApplicationProgramController_Cli extends AbstractController_Cli
{

    public function closeTerminatedAction()
    {
        foreach (ApplicationProgramRepository::findByStatus(ApplicationProgram::STATUS_OPEN) as $program) {
            $endDate = $program->getEndDateTime();
            if (!isset($endDate) || $endDate->getTimestamp() > time()) {
                continue;
            }
            $program->setStatus(ApplicationProgram::STATUS_CLOSED);
            ApplicationProgramRepository::persist($program);
        }

        MongoRepository::flush();
    }

}
