<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Repository\Research\ExpositionRepository;

class CacheController_Cli extends AbstractController_Cli
{

    public function warmupAction()
    {
        ob_end_clean();

        $helper = new My_View_Helper_ViewUrl();
        $urls = [];

        foreach (ExpositionRepository::findPublicButNotPublished() as $exposition) {
            foreach ($exposition->getWeaves() as $weave) {
                $urls[] = $helper->viewUrl($exposition, $weave);
            }
        }

        foreach (ExpositionRepository::findPublished() as $exposition) {
            foreach ($exposition->getWeaves() as $weave) {
                $urls[] = $helper->viewUrl($exposition, $weave);
            }
        }

        $count = count($urls);
        foreach ($urls as $key => $url) {
            echo 'executing ' . $url . ' (' . $key . '/' . $count . ')', PHP_EOL;

            file_get_contents($url);
        }
    }

}