<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Repository\MediaRepository;
use Rc\Domain\Repository\MongoRepository;
use Rc\Service\Ingest\IngestService;

class IngestController_Cli extends AbstractController_Cli
{

    public function processAction()
    {
        $media = MediaRepository::getById($this->getParam('uuid'));
        $ingestService = IngestService::factory($media->getMaster()->getUri());
        $ingestService::masterFromFile($media->getMaster()->getUri());

        MongoRepository::flush();
    }

    public function processSplashScreensAction()
    {
        foreach (MediaRepository::findByMasterContentType('image') as $media) {
            if (in_array($media->getSplashScreen()->getFileExtension(), ['png', 'gif', 'svg'])) {
                continue;
            }

            $master = $media->getMaster();
            $ingestService = IngestService::factory($master->getUri());

            $splashScreen = $ingestService::processSplashScreen($master);
            $media->setSplashScreen($splashScreen);

            MediaRepository::persist($media);
        }

        MongoRepository::flush();
    }
}