<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Repository\ResearchRepository;
use Rc\Domain\Repository\UserRepository;

class UserController_Cli extends AbstractController_Cli
{

    public function updateFlagsAction()
    {
        foreach (UserRepository::findAll() as $user) {
            $changed = false;

            if ($user->isLimitedUser()) {
                continue;
            }

            if ($user->isHidden()) {
                $user->setHide(false);
                $changed = true;
            }

            $hasPublicObjects = (bool)ResearchRepository::findOnePublicByPerson($user);
            if ($user->getHasPublicObjects() !== $hasPublicObjects) {
                $user->setHasPublicObjects($hasPublicObjects);
                $changed = true;
            }

            if ($changed) {
                UserRepository::persist($user);
            }
        }
        UserRepository::flush();
    }
}
