<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Repository\MediaRepository;
use Rc\Service\ZencoderService;

/**
 * @category  SAR.RC
 */
class ZencoderController_Cli extends AbstractController_Cli
{

    /**
     * @return void
     */
    public function transcodeAction()
    {
        ZencoderService::transcodeAll();
    }

    public function reTranscodeAction()
    {
        $media = MediaRepository::findById($this->getParam('media'));
        $media->clearDerivativeList();
        MediaRepository::persist($media);
        MediaRepository::flush();

        ZencoderService::transcode(new SplFileInfo($media->getMaster()->getUri()));
    }

}
