<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Repository\Research\DegreeRepository;
use Rc\Domain\Repository\Research\ExpositionRepository;
use Rc\Domain\Repository\Research\ProjectRepository;
use Rc\Domain\Repository\Research\WorkRepository;

class FeedController extends BasicControllerAction
{

    public function init()
    {
        $this->initPortal();
    }

    public function indexAction()
    {
        $this->view->researchList = ExpositionRepository::search([
            'portal'     => $this->_getParam('portal'),
            'accessible' => [false, false],
        ]);
        $this->_disableLayout();
    }

    public function workAction()
    {
        $this->view->workList = WorkRepository::search([
            'portal'     => $this->_getParam('portal'),
            'accessible' => [false, false],
        ]);
        $this->_disableLayout();
    }

    public function degreeAction()
    {
        $this->view->degreeList = DegreeRepository::search([
            'portal'     => $this->_getParam('portal'),
            'accessible' => [false, false],
        ]);
        $this->_disableLayout();
    }

    public function projectAction()
    {
        $this->view->projectList = ProjectRepository::search([
            'portal'     => $this->_getParam('portal'),
            'accessible' => [false, false],
        ]);
        $this->_disableLayout();
    }
}

?>