<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Media\MediaType;
use Rc\Domain\Repository\Research\ExpositionRepository;

class ScriptingController extends BasicControllerAction
{

    public function init()
    {
        $this->_disableView();
        #DilpsRepository::login('rc', 'admin');
    }

    public function indexAction()
    {
        echo 'deactivated';
        return false;
        $person = PersonRepository::findById(3959);
        $research = ExpositionRepository::findById(33841);
        $weave = WeaveRepository::findById(33842);

        $tools = explode("\n", file_get_contents(APPLICATION_PATH . '/../scripts/SpeakerNumbers2.csv'));
        foreach ($tools as $toolData) {
            $data = explode(',', $toolData);
            if ($data[0] == 'tool' || count($data) != 6) {
                echo '<br/>invalid tool data: ' . $toolData;
                continue;
            }

            $media = APPLICATION_PATH . '/../scripts/SpeakerNumbers2/' . $data[1] . '.aiff';
            if (!file_exists($media)) {
                echo '<br/>no media file: ' . $media;
                continue;
            }

            $file = FileRepository::findByTitle($data[1]);
            if (count($file) == 0) {
                $file = new File();
                $file->setMediaType($data[0])
                    ->setAuthor($person)
                    ->setResearch($research)
                    ->setCopyrightHolder('Gerhard Eckel')
                    ->setTitle($data[1])
                    ->setMedia($media);
                FileRepository::add($file);
            } else {
                $file = reset($file);
            }

            if (!$file->isShared($research->getId())) {
                $file->share($research->getId());
                FileRepository::updateRights($file, true);
            }

            if ($data[0] == 'audio') {
                $tool = new AudioTool();
            } else {
                echo '<br/>invalid tool: ' . $data[0];
                continue;
            }

            $tool->setAuthor($person)
                ->setTitle($data[1])
                ->setWeave($weave)
                ->setLeft($data[2] + $weave->getPaddingLeft(), $weave)
                ->setTop($data[3] + $weave->getPaddingTop(), $weave)
                ->setWidth($data[4])
                ->setHeight($data[5])
                ->setOpacity(Tool::CSS_OPACITY_VISIBLE)
                ->setZIndex($weave->getMaxZIndex() + 1)
                ->setPosition(Tool::POSITION_CENTER_CENTER)
                ->addResource($file);
            ItemRepository::add($tool);

            echo '<br/>' . $data[1] . ' imported: file[' . $file->getId() . '], tool[' . $tool->getId() . ']';
        }
    }

    public function arrangeImagesAction()
    {
        echo 'deactivated';
        return false;
        $person = PersonRepository::findById(499);
        $research = ExpositionRepository::findById(33841);
        $weave = WeaveRepository::findById(51382);

        /**
         * @var \DirectoryIterator $fileInfo
         */
        $orderedFileList = [];
        foreach (new \DirectoryIterator(APPLICATION_PATH . '/../2013-03_mindthegap_photos/') as $index => $fileInfo) {
            if ($fileInfo->isDir() === true) {
                continue;
            }

            $orderedFileList[$fileInfo->getBasename()] = [
                'basename' => $fileInfo->getBasename(),
                'realpath' => $fileInfo->getRealPath(),
            ];
        }
        ksort($orderedFileList);
        $orderedFileList = array_values($orderedFileList);

        foreach ($orderedFileList as $fileInfo) {
            $imagick = new Imagick();
            $imagick->readimage($fileInfo['realpath']);

            if ($imagick->getimagewidth() > 768 && $imagick->getimagewidth() > $imagick->getimageheight()) {
                $width = 768;
                $height = 768 / $imagick->getimagewidth() * $imagick->getimageheight();
            } else if ($imagick->getimageheight() > 768) {
                $height = 768;
                $width = 768 / $imagick->getimageheight() * $imagick->getimagewidth();
            } else {
                continue;
            }

            $imagick->resizeImage($width, $height, imagick::FILTER_LANCZOS, 1);
            $imagick->writeimage($fileInfo['realpath']);
        }

        foreach ($orderedFileList as $index => $fileInfo) {
            echo '<br/>', $fileInfo['realpath'];

            $file = new File();
            $file->setMediaType(MediaType::IMAGE)
                ->setAuthor($person)
                ->setResearch($research)
                ->setCopyrightHolder('Udo Stelzer')
                ->setTitle(substr($fileInfo['basename'], 0, -4))
                ->setMedia($fileInfo['realpath']);
            FileRepository::add($file);

            if (!$file->isShared($research->getId())) {
                $file->share($research->getId());
                FileRepository::updateRights($file, true);
            }

            $media = $file->getMedia();
            if ($media['orgHeight'] === null || $media['orgWidth'] === null) {
                break;
            }

            if ($media['orgWidth'] > $media['orgHeight']) {
                $width = 160;
                $height = $media['orgHeight'] / ($media['orgWidth'] / 160);
            } else {
                $height = 160;
                $width = $media['orgWidth'] / ($media['orgHeight'] / 160);
            }

            $tool = new \Rc\Domain\Model\Research\Exposition\Weave\Tool\PictureTool();
            $tool->setAuthor($person)
                ->setTitle(substr($fileInfo['basename'], 0, -4))
                ->setWeave($weave)
                ->setLeft(155 + ($index % 18) * 180 - $width / 2 + $weave->getPaddingLeft(), $weave)
                ->setTop(112 + floor($index / 18) * 180 - $height / 2 + $weave->getPaddingTop(), $weave)
                ->setWidth($width)
                ->setHeight($height)
                ->setOpacity(Tool::CSS_OPACITY_VISIBLE)
                ->setZIndex($weave->getMaxZIndex() + 1)
                ->setPosition(Tool::POSITION_CENTER_CENTER)
                ->setOpenPictureInPopup(true)
                ->addResource($file);
            ItemRepository::add($tool);
        }
    }

    public function hddAction()
    {
        echo 'deactivated';
        return false;
        $person = PersonRepository::findById(25116);
        $research = ExpositionRepository::findById(25325);

        foreach (file(APPLICATION_PATH . '/../hdd.csv') as $line) {
            $parts = explode(';', $line);
            if (empty($parts[1])) { // work
                $work = new Work();
                $work->setAuthor($person)
                    ->setParent($person->getRepositoryBag())
                    ->setGenre('video')
                    ->setTitle($parts[2])
                    ->setDate($parts[3])
                    ->setCopyrightHolder($parts[4]);
                WorkRepository::add($work);
                echo '<br/>work:', $work->getId();
            } else { // file
                $file = new File();
                $file->setAuthor($person)
                    ->setResearch($research)
                    ->setWork($work)
                    ->setMediaType(MediaType::VIDEO)
                    ->setTitle($parts[2])
                    ->setDate($parts[3])
                    ->setCopyrightHolder($parts[4]);
                if (file_exists($parts[1])) {
                    $file->setMedia($parts[1]);
                } else {
                    echo '<br>', $work->getId(), ',', $file->getId(), ',', 'file not extist:', $parts[1];
                }
                FileRepository::add($file);
                echo '<br/>file:', $file->getId();
            }
        }
    }
}

?>