<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Repository\ObjectShareRepository;
use Rc\Domain\Repository\ResearchRepository;

class SharedController extends BasicControllerAction
{

    /**
     * @param string $method
     * @param array $args
     * @return mixed
     */
    public function __call($method, $args)
    {
        $pieces = explode('/', $_SERVER['REDIRECT_URL']);

        $this->forward('index', null, null, [
            'secret' => end($pieces),
        ]);

        return null;
    }

    public function init()
    {
        $this->initPortal();
    }

    public function indexAction()
    {
        $objectShare = ObjectShareRepository::findBySecret($this->getParam('secret'));
        if (!isset($objectShare)) {
            return;
        }

        Zend_Registry::get('RC_DILPS_AUTH')->addSessionReadGroupFor($objectShare->getEntityId());

        $entity = ResearchRepository::findById($objectShare->getEntityId());
        if (!isset($entity)) {
            return;
        }

        $this->redirect($this->view->url()->entityUrl($entity));
    }

}
