<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Repository\UserRepository;

class UserController extends BasicControllerAction
{

    public function searchAction()
    {
        $this->_disableView();

        $field = $this->_getParam('property', 'name');
        $searchTerm = $this->_getParam('value', $this->getParam('name'));
        $options = [
            'excludeHidden' => $this->getParam('hidden-profile') == 'true',
            'limit'         => 10,
        ];

        $retVal = [];
        foreach (UserRepository::suggest($field, $searchTerm, $options) as $suggest) {
            if ($this->_getParam('excludeCurrentUser') && $suggest->getEntityId() == Identity::getUserId()) {
                continue;
            }

            $retVal[] = [
                'value' => $suggest->getEntityId(),
                'label' => $suggest->getMatch(),
            ];
        }

        header('Content-Type: application/json');
        echo json_encode($retVal);
    }
}
