<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class LoginFormGenerator extends BasicFormGenerator
{

    public static function get()
    {
        $form = new DefaultForm();
        $form->setTitle('dialog.session.expired')
            ->setAttrib('action', '/session/login');

        $form->addElement('html', 'info', [
            'value' => static::_getTranslate()->translate('info.session.expired'),
        ])
            ->addElement('html', 'error', [
                'value' => '',
                'class' => 'error',
                'style' => 'padding-top: 10px',
            ])
            ->addElement('text', 'username', [
                'required' => true,
                'label'    => 'field.email',
            ])
            ->addElement('password', 'password', [
                'required' => true,
                'label'    => 'field.password',
            ]);

        $form->addCancelButton()->addSubmitButton();

        return $form;
    }

}

?>