<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class MyLocal extends Zend_Locale
{

    /**
     * @var array
     */
    private static $languageList = array(
        'en' => 'english (eng)',
        'nl' => 'nederlands (nld)',
        'et' => 'eesti keel (est)',
        'fi' => 'suomi (fin)',
        'fr' => 'français (fra)',
        'de' => 'deutsch (deu)',
        'no' => 'norsk (nor)',
        'sv' => 'svenska (swe)',
        'es' => 'español (spa)',
        'pt' => 'português (por)',
        'it' => 'italiano (ita)',
        'da' => 'dansk (dan)',
        'lt' => 'lithuania (lit)',
    );

    public static function getTranslationList($path = null, $locale = null, $value = null)
    {
        $list = parent::getTranslationList($path, $locale, $value);
        switch (strtolower($path)) {
            case 'language':
                return self::$languageList;
            default:
                return $list;
        }
    }

    public function getLocale()
    {
        return $this->_locale;
    }

    public function getDefaultDateFormatForUser()
    {
        $dateFormat = Zend_Registry::get('Zend_Translate')->translate('date.format');
        if ($dateFormat == 'date.format') {
            $dateFormat = config('app.date.format');
        }

        return $dateFormat;
    }

    public function getDefaultDateFormatForPhp()
    {
        return str_replace(array('yyyy', 'yy', 'mm', 'dd'), array('Y', 'y', 'm', 'd'), $this->getDefaultDateFormatForUser());
    }

    public function getDefaultDateFormatForJs()
    {
        return str_replace(array('yyyy'), array('yy'), $this->getDefaultDateFormatForUser());
    }

    public function getDefaultDateTimeFormatForUser()
    {
        $dateTimeFormat = Zend_Registry::get('Zend_Translate')->translate('datetime.format');
        if ($dateTimeFormat == 'dateTime.format') {
            $dateTimeFormat = config('app.datetime.format');
        }

        return $dateTimeFormat;
    }

    public function getDefaultDateTimeFormatForPhp()
    {
        return str_replace(array('yyyy', 'yy', 'mm', 'dd'), array('Y', 'y', 'm', 'd'), $this->getDefaultDateTimeFormatForUser());
    }

    public function getDefaultDateTimeFormatForJs()
    {
        return str_replace(array('yyyy'), array('yy'), $this->getDefaultDateTimeFormatForUser());
    }

}

?>