<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class SecurityPlugin extends Zend_Controller_Plugin_Abstract
{

    public function preDispatch(Zend_Controller_Request_Abstract $request)
    {
        $this->guardSecuredRequestUri();
    }

    protected function guardSecuredRequestUri() {
        // e.g. /profile/show-work?work=131316%27A=0
        $securedRequestUri = str_replace(['\'A=0', '%27A=0'], '', $_SERVER['REQUEST_URI']);

        // e.g. /profile/show-work?work=131316%3Fwork%3D131316
        if (preg_match('~\?\w+=\d+%3F~', $securedRequestUri)) {
            $securedRequestUri = substr($securedRequestUri, 0, strrpos($securedRequestUri, '%3F'));
        }

        if ($securedRequestUri == $_SERVER['REQUEST_URI']) {
            return;
        }

        header('Location: ' . $securedRequestUri, true, 301);
        exit();
    }

}

?>