<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_Filter_HtmLawed implements Zend_Filter_Interface
{
    /**
     * Defined by Zend_Filter_Interface
     *
     * Returns the string $value, converting characters to their corresponding HTML entity
     * equivalents where they exist
     *
     * @param  string $value
     * @return string
     */
    public function filter($value)
    {
        if (is_array($value)) {
            array_walk_recursive(
                $value,
                function (&$value) {
                    $value = Htmlawed::filter($value, ['safe' => 1]);
                }
            );
            return $value;
        } else {
            return Htmlawed::filter($value, ['safe' => 1]);
        }
    }
}
