<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_Zend_Form_Element_AwardingInstitutions extends Zend_Form_Element_Xhtml
{

    public $helper = 'formAwardingInstitutions';

    protected $_isArray = true;

    public function isValid($value, $context = null)
    {
        if (!$this->getValidator('InArray')) {
            $this->addValidator(
                'InArray',
                true,
                array(array_keys($this->getAttrib('countries')))
            );
        }

        $valid = parent::isValid(array_map(function ($value) {
                return $value['country'];
            }, $value), $context);

        if ($valid) {
            $this->removeValidator('InArray');
            parent::isValid(array_map(function ($value) {
                return $value['institution'];
            }, $value), $context);
        }

        $this->setValue(array_values($value));

        return $valid;
    }

}

?>