<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_Zend_Form_Element_Number extends Zend_Form_Element_Xhtml
{

    /**
     * Default form view helper to use for rendering
     * @var string
     */
    public $helper = 'formNumber';

    public function init()
    {
        $attribs = $this->getAttribs();
        if (!isset($attribs['defaultValidators']) || $attribs['defaultValidators']) {
            $this->addValidator('float');
            $inclusive = !empty($attribs['inclusive']);
            if (isset($attribs['min'])) {
                $this->addValidator('greaterThan', false, array('min' => $attribs['min'], 'inclusive' => $inclusive));
            }
            if (isset($attribs['max'])) {
                $this->addValidator('LessThan', false, array('max' => $attribs['max'], 'inclusive' => $inclusive));
            }
        }
    }

}

?>