<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Repository\MongoRepository;

class My_Validate_NoRecordExists extends Zend_Validate_Db_NoRecordExists
{

    /**
     * @inheritdoc
     */
    public function __construct($options)
    {
        $options['table'] = '';
        parent::__construct($options);
    }

    /**
     * @inheritdoc
     */
    public function setAdapter($adapter)
    {
        $this->_adapter = $adapter;
        return $this;
    }

    /**
     * @inheritdoc
     */
    protected function _query($value)
    {
        /** @var MongoRepository $adapter */
        $adapter = $this->getAdapter();

        $query = [
            $this->_field => trim((string)$value),
        ];
        if (!empty($this->_exclude['value'])) {
            $query[$this->_exclude['field']] = ['$ne' => $this->_exclude['value']];
        }

        return $adapter->findOne($query);
    }
}
