<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Utility\Strings;

/**
 * @deprecated
 */
abstract class AbstractEntity implements IEntity
{

    abstract function getId();

    public function setValues(array $values)
    {
        foreach ($values as $attribute => $value) {
            $method = 'set' . Strings::toCamelCase($attribute, '-');
            if (method_exists($this, $method) == false) {
                continue;
            }

            // multiple languages
            if (is_array($value) && count($value) > 0 && count(array_filter(array_keys($value), 'is_numeric')) == 0) {
                foreach ($value as $lkey => $lvalue) {
                    $this->$method($lvalue, $lkey);
                }
            } else {
                $this->$method($value);
            }
        }

        return $this;
    }

}

?>