<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class Announcement extends MySqlEntity
{

    protected $id;

    protected $subject;

    protected $content;

    protected $created;

    protected $approved;

    /**
     * @var int
     */
    protected $newsletterid;

    /**
     * @var Newsletter
     */
    private $newsletter;

    public function __construct($data = null)
    {
        static::_setDefaultValues();
        parent::__construct($data);
    }

    // Id

    public function getId()
    {
        return $this->id;
    }

    public function setId($id)
    {
        $this->id = $id;
        return $this;
    }

    public function getContent()
    {
        return $this->content;
    }

    public function setContent($content)
    {
        $this->content = $content;
    }

    /**
     * @return int
     */
    public function getNewsletterid()
    {
        return $this->newsletterid;
    }

    /**
     * @param int $newsletterid
     * @return void
     */
    public function setNewsletterid($newsletterid)
    {
        $this->newsletterid = $newsletterid;
    }

    /**
     * @return Newsletter
     */
    public function getNewsletter()
    {
        if (!isset($this->newsletter)) {
            $this->newsletter = NewsletterRepository::findById($this->newsletterid);
        }
        return $this->newsletter;
    }

    /**
     * @param Newsletter $newsletter
     * @return void
     */
    public function setNewsletter($newsletter)
    {
        $this->newsletter = $newsletter;
        $this->newsletterid = $newsletter->getId();
    }

    /**
     * @return mixed
     */
    public function getApproved()
    {
        return $this->approved;
    }

    /**
     * @param mixed $approved
     * @return void
     */
    public function setApproved($approved)
    {
        $this->approved = $approved;
    }

    public function getCreated()
    {
        return $this->_parseDateTimeForGetter($this->created);
    }

    public function setCreated($date)
    {
        $this->created = $this->_parseDateTimeForSetter($date);
    }

    /**
     * @return mixed
     */
    public function getSubject()
    {
        return $this->subject;
    }

    /**
     * @param mixed $subject
     * @return void
     */
    public function setSubject($subject)
    {
        $this->subject = $subject;
    }

    protected function _setDefaultValues()
    {
        $this->setCreated(time());

        return $this;
    }

}

?>