<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

/**
 * @deprecated
 */
class MySqlEntity extends AbstractEntity
{

    public function __construct($data = null)
    {
        foreach ((array)$data as $key => $value) {
            if (property_exists(get_called_class(), $key)) {
                $this->{$key} = $value;
            }
        }
    }

    public function setId($id)
    {
        $this->id = $id;
        return $this;
    }

    public function getId()
    {
        return $this->id;
    }

    public function __call($method, $args)
    {
        if (substr($method, 0, 3) == 'get') {
            return static::_getProperty(lcfirst(substr($method, 3)));
        } else if (substr($method, 0, 3) == 'set') {
            return static::_setProperty(lcfirst(substr($method, 3)), $args[0]);
        } else {
            throw new Exception('UNKNOWN_METHOD [' . $method . ']');
        }
    }

    function getProperties($use_getter = true)
    {
        $retVal = [];
        $reflection = new ReflectionClass(get_called_class());
        $properties = $reflection->getProperties(ReflectionProperty::IS_PROTECTED);

        foreach ($properties as $property) {
            if ($use_getter) {
                $method = 'get' . ucfirst($property->getName());
                $retVal[$property->getName()] = static::$method();
            } else {
                $retVal[$property->getName()] = $this->{$property->getName()};
            }
        }

        return $retVal;
    }

    function setProperties($properties)
    {
        foreach ((array)$properties as $property => $value) {
            if (static::_isProperty($property)) {
                $method = 'set' . ucfirst($property);
                static::$method($value);
            }
        }
    }

    protected function _parseDateTimeForSetter($dateTime)
    {
        if (is_numeric($dateTime)) {
            $retVal = date('Y-m-d H:i:s', $dateTime);
        } else {
            $retVal = $dateTime;
        }

        return $retVal;
    }

    protected function _parseDateTimeForGetter($dateTime)
    {
        if ($dateTime) {
            list($year, $month, $day, $hour, $minute, $second) = preg_split('~[^0-9]~i', $dateTime, -1, PREG_SPLIT_NO_EMPTY);
            $retVal = mktime($hour, $minute, $second, $month, $day, $year);
        } else {
            $retVal = null;
        }

        return $retVal;
    }

    protected function _isProperty($property)
    {
        return property_exists(get_called_class(), $property);
    }

    protected function _getProperty($property)
    {
        if (static::_isProperty($property)) {
            return $this->{$property};
        } else {
            throw new Exception('UNKNOWN_PROPERTY [' . $property . ']');
        }
    }

    protected function _setProperty($property, $value)
    {
        if (static::_isProperty($property)) {
            $this->{$property} = $value;
        } else {
            throw new Exception('UNKNOWN_PROPERTY [' . $property . ']');
        }
    }

}

?>