<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class Update extends MySqlEntity
{

    /**
     * @var int
     */
    protected $id;

    /**
     * @var string
     */
    protected $date;

    /**
     * @var string
     */
    protected $content;

    /**
     * @var string
     */
    protected $subject;

    /**
     * @var bool
     */
    protected $terminated;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     * @return void
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return string
     */
    public function getContent()
    {
        return $this->content;
    }

    /**
     * @param string $content
     * @return void
     */
    public function setContent($content)
    {
        $this->content = $content;
    }

    /**
     * @return string
     */
    public function getSubject()
    {
        return $this->subject;
    }

    /**
     * @param string $subject
     * @return void
     */
    public function setSubject($subject)
    {
        $this->subject = $subject;
    }

    public function getDate()
    {
        return $this->_parseDateTimeForGetter($this->date);
    }

    public function setDate($date)
    {
        $this->date = $this->_parseDateTimeForSetter($date);
    }

    /**
     * @return string
     */
    public function getState()
    {
        if ($this->getTerminated()) {
            return 'terminated';
        } else {
            return 'inprogress';
        }
    }

    /**
     * @return boolean
     */
    public function getTerminated()
    {
        return $this->terminated;
    }

    /**
     * @param boolean $terminated
     * @return void
     */
    public function setTerminated($terminated)
    {
        $this->terminated = $terminated;
    }

}

?>