<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

/**
 * @method static ProfileShortcut findById($id, $limit = null)
 */
class ProfileShortcutRepository extends MySqlRepository
{

    /**
     * @param int $userId
     * @param int $page
     * @param int $limit
     * @param array $orderBy
     * @return ProfileShortcut[]
     */
    public static function findByUserId($userId, $page = null, $limit = null, array $orderBy = null)
    {
        $result = static::_query('
            SELECT
                ' . static::_getFields() . '
            FROM
                ' . static::_getJoinedTables() . '
            WHERE
                userid = ' . static::_escape($userId) . '
            ORDER BY
                ' . static::_getValidOrderBy($orderBy) . '
            LIMIT
                ' . static::_getLimit($page, $limit) . '
        ');
        return static::_fetchAndFreeResults($result);
    }

    /**
     * @param int $userId
     * @param int $entityId
     * @return ProfileShortcut
     */
    public static function findByUserIdAndEntityId($userId, $entityId)
    {
        $result = static::_query('
            SELECT
                ' . static::_getFields() . '
            FROM
                ' . static::_getJoinedTables() . '
            WHERE
                userid = ' . static::_escape($userId) . ' AND
                entityid = ' . static::_escape($entityId) . '
        ');
        return static::_fetchAndFreeResult($result);
    }

}