<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_Form_Decorator_JQueryOnLoadActions extends Zend_Form_Decorator_Abstract
{

    public function render($content)
    {
        $form = $this->getElement();
        if (!$form instanceof Zend_Form) {
            return $content;
        }

        if (null === $form->getView()) {
            return $content;
        }

        $output = $form->getView()->jQueryOnLoadActions();

        $separator = $this->getSeparator();
        switch ($this->getPlacement()) {
            case (self::PREPEND):
                return $output . $separator . $content;
            case (self::APPEND):
            default:
                return $content . $separator . $output;
        }
    }

}

?>