<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_Form_Decorator_Label extends Zend_Form_Decorator_Abstract
{

    public function render($content)
    {
        $element = $this->getElement();
        $label = $element->getLabel();

        if (!$element instanceof Zend_Form_Element || null === $element->getView() || empty($label)) {
            return $content;
        }

        $id = $element->getId() ? $element->getId() : $element->getFullyQualifiedName();
        $attribs = [];

        if ($element->getMessages() != null) {
            $element->setAttrib('class', 'error ' . $element->getAttrib('class'));
        }

        if ($element->isRequired() && $element->getAttrib('readonly') != 'readonly') {
            $label .= '*';
        }

        if (preg_match('~display\:\s*none~i', $element->getAttrib('style')) > 0) {
            $attribs['style'] = 'display:none';
        }

        $output = $element->getView()->formLabel($id, $label, $attribs);

        $separator = $this->getSeparator();
        switch ($this->getPlacement()) {
            case (self::PREPEND):
                return $output . $separator . $content;
            case (self::APPEND):
            default:
                return $content . $separator . $output;
        }
    }

}

?>