<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Portal;
use Rc\Domain\Model\Research;
use Rc\Domain\Model\User;

class My_View_Helper_FeedLink extends Zend_View_Helper_Abstract
{
    /**
     * @param Research|Portal|User $target
     * @param string $type
     * @param array $attribs
     * @return string
     * @throws Exception
     */
    public function feedLink($target, $type = 'entity', $attribs = [])
    {
        if (!Identity::exists()) {
            return null;
        }
        if ($type == 'user' && Identity::getUser() === $target) {
            return null;
        }

        if ($type == 'entity') {
            $follows = Identity::getUser()->followsEntity($target);
        } elseif ($type == 'portal') {
            $follows = Identity::getUser()->followsPortal($target);
        } else {
            $follows = Identity::getUser()->followsUser($target);
        }

        if ($follows) {
            $label = 'action.unfollow';
            $reverseLabel = 'action.follow';
        } else {
            $label = 'action.follow';
            $reverseLabel = 'action.unfollow';
        }

        return $this->view->htmlElement('a', $this->view->translate($label), $attribs + [
                'href'        => 'javascript:',
                'onclick'     => 'toggleFeedFollowing(' . $target->getId() . ', \'' . $type . '\', $(this));',
                'data-follow' => (int)$follows,
                'data-label'  => $this->view->translate($reverseLabel),
            ]);
    }

}
