<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_View_Helper_FileSize extends Zend_View_Helper_Abstract
{

    public function fileSize($bytes)
    {
        $bytes = floatval($bytes);
        $arBytes = [
            0 => [
                "UNIT"  => "TB",
                "VALUE" => pow(1024, 4),
            ],
            1 => [
                "UNIT"  => "GB",
                "VALUE" => pow(1024, 3),
            ],
            2 => [
                "UNIT"  => "MB",
                "VALUE" => pow(1024, 2),
            ],
            3 => [
                "UNIT"  => "KB",
                "VALUE" => 1024,
            ],
            4 => [
                "UNIT"  => "B",
                "VALUE" => 1,
            ],
        ];

        foreach ($arBytes as $arItem) {
            if ($bytes >= $arItem["VALUE"]) {
                $result = $bytes / $arItem["VALUE"];
                $result = str_replace(".", ",", strval(round($result, 2))) . " " . $arItem["UNIT"];
                break;
            }
        }
        return $result;
    }
}
