<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class Zend_View_Helper_FormColor extends Zend_View_Helper_FormElement
{

    public function formColor($name, $value = null, $attribs = null)
    {
        $attribs['data-colorpicker'] = true;
        $info = $this->_getInfo($name, $value, $attribs);
        extract($info); // name, value, attribs, options, listsep, disable
        // is it disabled?
        $disabled = '';
        if ($disable) {
            $disabled = ' disabled="disabled"';
        }

        // XHTML or HTML end tag?
        $endTag = ' />';
        if (($this->view instanceof Zend_View_Abstract) && !$this->view->doctype()->isXhtml()) {
            $endTag = '>';
        }

        // render the element
        $xhtml = '<input type="text"'
            . ' name="' . $this->view->escape($name) . '"'
            . ' id="' . $this->view->escape($id) . '"'
            . ' value="' . $this->view->escape($value) . '"'
            . $disabled
            . $this->_htmlAttribs($attribs)
            . $endTag;

        $this->view->jQuery()->addOnLoad(
            sprintf('%s("[id=%s]:last").colorpicker({color:"%s",eventName:"focus",onSubmit:function(hsb,hex,rgb,el){%1$s(el).val("#"+hex);%1$s(el).colorpickerHide();}});',
                ZendX_JQuery_View_Helper_JQuery::getJQueryHandler(), $id, $value)
        );

        return $xhtml;
    }

}

?>