<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class Zend_View_Helper_FormLanguageBar extends Zend_View_Helper_FormElement
{

    public $view;

    public function setView(Zend_View_Interface $view)
    {
        $this->view = $view;
    }

    public function formLanguageBar($name, $languageList = null, $attribs = null)
    {
        if (empty($languageList)) {
            $languageList = MyLocal::getTranslationList('language');
        }

        $defaultLanguage = config('app.lang');
        $activeLanguage = $this->_getRequest()->getParam($name, $defaultLanguage);
        foreach ($languageList as $key => $value) {
            if ($activeLanguage == $key) {
                $selected = ' selected="selected"';
            } else {
                $selected = '';
            }
            $options[] = '<option value="' . $key . '"' . $selected . '>' . $value;
        }

        $htmlAttribs = $this->_htmlAttribs($attribs + [
                'data-default-language' => $defaultLanguage,
                'style'                 => 'width:100px',
                'onchange'              => 'changeLanguage(this)',
            ]);

        return '
        <div class="language-bar">
            <select' . $htmlAttribs . '>' . implode(null, $options) . '</select>
        </div>';
    }

    protected function _getRequest()
    {
        return Zend_Controller_Front::getInstance()->getRequest();
    }

}

?>