<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_View_Helper_HighlightActiveMenuEntry extends Zend_View_Helper_Abstract
{

    protected $request;

    public function __construct()
    {
        $this->request = Zend_Controller_Front::getInstance()->getRequest();
    }

    public function highlightActiveMenuEntry($controller, $action = null, $params = [])
    {
        if (!isset($action)) {
            $action = 'index';
        }
        $active = $this->request->getControllerName() == $controller && $this->request->getActionName() == $action;

        foreach ($params as $key => $value) {
            $active &= ($value == $this->request->getParam($key));
        }

        if ($active) {
            $retVal = ' class="active" ';
        } else {
            $retVal = '';
        }

        return $retVal;
    }

}

?>