<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Research\Exposition\Weave\Tool\ShapeTool;

/**
 * @property ShapeTool $tool
 */
class My_View_Helper_ShapeToolDecorator extends My_View_Helper_ToolDecorator
{

    public function shapeToolDecorator(ShapeTool $tool, $renderFor = self::RENDER_FOR_EDITOR)
    {
        $this->_init($tool, $renderFor);
        return $this->_renderTool();
    }

    public function _getToolContentForEditor($options = [])
    {
        return ShapeFactory::createShapeByType($this->tool->getShapeContent(), $this->tool->getWidth(), $this->tool->getHeight(), [
            'fill'   => $this->tool->getFillColor(),
            'stroke' => $this->tool->getStroke(),
        ]);
    }

    public function _getToolContentForView($options = [])
    {
        return ShapeFactory::createShapeByType($this->tool->getShapeContent(), $this->tool->getWidth(), $this->tool->getHeight(), [
            'fill'   => $this->tool->getFillColor(),
            'stroke' => $this->tool->getStroke(),
        ]);
    }

    protected function _showToolInView()
    {
        return true;
    }
}

?>