<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

use Rc\Domain\Model\Research\Exposition\Weave\Tool\SimpletextTool;

/**
 * @property SimpletextTool $tool
 */
class My_View_Helper_SimpletextToolDecorator extends My_View_Helper_ToolDecorator
{

    /**
     * @param SimpletextTool $tool
     * @param string $renderFor
     * @return mixed
     */
    public function SimpletextToolDecorator($tool, $renderFor = self::RENDER_FOR_EDITOR)
    {
        $this->_init($tool, $renderFor);
        $this->attributes['class'] .= ' ' . $this->tool->getScrollbarVisibility();
        if (strpos($this->tool->getTextContent(), 'class="del cts-1"') !== false || strpos($this->tool->getTextContent(), 'class="ins cts-1"') !== false) {
            $this->attributes['class'] .= ' track-changes';
        }
        return $this->_renderTool();
    }

    protected function _getToolContentForView($options = [])
    {
        $retVal = $this->view->simpleText($this->tool->getTextContent());
        $retVal = $this->_parsePopovers($retVal);
        return $retVal;
    }

    protected function _getToolContentForEditor($options = [])
    {
        $retVal = $this->view->simpleText($this->tool->getTextContent());
        $retVal = $this->_parsePopovers($retVal);
        return $retVal;
    }

    protected function _showToolInView()
    {
        return true;
    }

}

?>