<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_View_Helper_ToolIconClass extends Zend_View_Helper_Abstract
{

    const TOOL_PICTURE = 'picture';
    const TOOL_SLIDESHOW = 'slideshow';
    const TOOL_VIDEO = 'video';
    const TOOL_AUDIO = 'audio';
    const TOOL_TEXT = 'text';
    const TOOL_SIMPLE_TEXT = 'simpletext';
    const TOOL_PDF = 'pdf';
    const TOOL_PLAY = 'play';
    const TOOL_SHAPE = 'shape';
    const TOOL_COMMENT = 'comment';
    const TOOL_EMBED = 'embed';
    const TOOL_OBJECT_VIEWER = 'objectviewer';

    public function toolIconClass($mediaType)
    {
        switch ($mediaType) {
            case 'image':
                return 'file-picture';
            case 'video':
                return 'file-video';
            case 'audio':
                return 'file-music';
            case 'simpletext':
                return 'file-text';
            case 'text':
                return 'file-code';
            case 'pdf':
                return 'file-pdf';
            case 'archive':
                return 'file-zip';
            default:
                return 'file-empty';
        }
    }

}

?>