<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_View_Helper_Wrap extends Zend_View_Helper_Abstract
{

    public function wrap($object, $wrapBefore, $wrapBehind = null, $escape = true)
    {
        if (!isset($wrapBehind)) {
            $wrapBehind = $wrapBefore;
        }

        if (empty($object)) {
            $retVal = null;
        } else if (is_string($object) || is_int($object)) {
            $retVal = $this->wrapString($object, $wrapBefore, $wrapBehind, $escape);
        } else if (is_array($object)) {
            $retVal = $this->wrapArray($object, $wrapBefore, $wrapBehind, $escape);
        } else {
            throw new Exception('UNSUPPORTED_PARAMETER_TYPE');
        }

        return $retVal;
    }

    public function wrapString($string, $wrapBefore, $wrapBehind, $escape)
    {
        if ($escape) {
            return $this->view->escape($wrapBefore . $string . $wrapBehind);
        } else {
            return $wrapBefore . $string . $wrapBehind;
        }
    }

    public function wrapArray($array, $wrapBefore, $wrapBehind, $escape)
    {
        foreach ($array as $key => $value) {
            $array[$key] = $this->wrapString($value, $wrapBefore, $wrapBehind, $escape);
        }
        return $array;
    }

}

?>