<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

class My_JQuery_View_Helper_JQueryOnLoadActions extends Zend_View_Helper_Abstract
{

    public $view;

    public function setView(Zend_View_Interface $view)
    {
        $this->view = $view;
    }

    public function JQueryOnLoadActions($printScriptTag = true)
    {
        $onLoadActions = $this->view->jQuery()->getOnLoadActions();
        $jsToPrint = sprintf('if(typeof $ != "undefined"){$(function(){%s})}', implode('', (array)$onLoadActions));

        if (empty($onLoadActions)) {
            $retVal = '';
        } else if ($printScriptTag) {
            $retVal = PHP_EOL . '<script type="text/javascript">' . $jsToPrint . '</script>';
        } else {
            $retVal = $jsToPrint;
        }
        return $retVal;
    }

}

?>