<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

return [

    'phpsettings' => [
        'display_errors'         => env('APP_DEBUG') ? 'on' : 'off',
        'display_startup_errors' => env('APP_DEBUG') ? 'on' : 'off',
        'error_reporting'        => E_ALL & ~E_DEPRECATED,
    ],

    'bootstrap' => [
        'path'  => app_path('Bootstrap.php'),
        'class' => Bootstrap::class,
    ],

    'resources' => [
        'frontController' => [
            'controllerDirectory' => app_path('controllers'),
            'actionHelperPaths'   => [
                'My_Controller_Action_Helper' => app_path('controllers/helpers'),
            ],
            'params'              => [
                'displayExceptions' => env('APP_DEBUG'),
            ],
        ],
        'view'            => [
            'helperPath' => [
                'ZendX_JQuery_View_Helper' => base_path('vendor/zendframework/zf1-extras/library/ZendX/JQuery/View/Helper'),
                'My_JQuery_View_Helper'    => app_path('views/helpers/jquery'),
                'My_View_Helper'           => app_path('views/helpers'),
            ],
        ],
    ],
];