function MadekList(init) {
	var $this = this;

	this.URL = '/madek/list';
	this.CONTAINER = $('#sidebar-madek');
	this.CONTAINER_SCROLL = $('.sidebar-list', this.CONTAINER)
	this.CONTAINER_CONTENT = $('.sidebar-list', this.CONTAINER);
	this.CONTAINER_TOOLBAR = $('.sidebar-toolbar', this.CONTAINER);
	this.CONTAINER_LOADING = $('.container-loading', this.CONTAINER);
	this.SELECTOR_CHILD = 'li';

	this.page = 1;
	this.loadingMoreResults = true;

	this.eAfterLoad = function() {
		this.children().each(function() {
			$this.initChild(this);
		});
		jQueryNew(this.CONTAINER_SCROLL).scrollTo(0, 0);
		this.ELEMENT_LOADING = $('<li class="loading"><em>Loading</em></li>').appendTo(this.CONTAINER_CONTENT);
		this.loadingMoreResults = false;
	};

	this.initChild = function(item) {
		(item = $(item)).click(function(event) {
			if (event.ctrlKey || event.metaKey) {
				$this.toggleChildSelection(item.data('id'));
			} else {
				$this.selectChild(item.data('id'));
			}
		}).dblclick(function() {
			}).disableSelection();

		$(item).children('img').each(function() {
			$(this).parent().addClass('tool-draggable').draggable({
				helper: function() {
					return $('<div id="tool-dragging"></div>').css({
						width: $(this).attr('data-size-width'),
						height: $(this).attr('data-size-height')
					});
				},
				drag: Editor.ContentList.adjustContainerSize,
				cursorAt: {
					left: 3,
					top: 3
				},
				opacity: 0.7,
				appendTo: Editor.ContentList.CONTAINER_CONTENT
			})
		});
	};

	this.loadMoreResults = function() {
		this.loadingMoreResults = true;
		$.ajax({
			url: this.URL,
			data: {
				page: ++this.page
			},
			context: this,
			success: function(data) {
				if (data == '') {
					this.ELEMENT_LOADING.hide();
				} else {
					$(data).each(function() {
						$this.initChild(this);
					}).appendTo(this.CONTAINER_CONTENT);
					this.ELEMENT_LOADING.appendTo(this.CONTAINER_CONTENT);
					this.loadingMoreResults = false;
				}
			}
		});
	}
	this.init = function() {
		this.CONTAINER_SCROLL.scroll(function() {
			if ($this.loadingMoreResults === false &&
			    $this.CONTAINER_SCROLL.scrollTop() + 500 > $this.CONTAINER_SCROLL[0].scrollHeight - $this.CONTAINER_SCROLL.innerHeight()) {
				$this.loadMoreResults();
			}
		});
	}

	if (!MadekList.prototype.init) {
		MadekList.prototype = new List(init);
		MadekList.prototype.constructor = MadekList;
	}

	if (init) this.init();
}
new MadekList();