function MadekMediaList(init) {
    const $this = this;

    this.URL = '/madek-media/list?research=' + Editor.getResearchId();
    this.CONTAINER = $('#_madek');
    this.CONTAINER_CONTENT = $('tbody', this.CONTAINER);
    this.CONTAINER_TABLE = $('.table', this.CONTAINER);
    this.CONTAINER_SCROLL = $('.dataTables_scrollBody', this.CONTAINER);
    this.CONTAINER_TOOLBAR = $('.t-menu', this.CONTAINER);
    this.CONTAINER_LOADING = $('.container-loading', this.CONTAINER);
    this.SELECTOR_CHILD = 'tr';

    this.setupDataTable = function () {
        jQueryNew(this.CONTAINER_TABLE).DataTable({
            columnDefs: [
                {
                    orderable: true
                }
            ],
            columns: [
                {type: 'string', orderDataType: 'rc-tool', width: 40},
                {type: 'string'},
                {type: 'date',orderDataType: 'rc-date',  width: 85}
            ],
            fixedColumns: true,
            bAutoWidth: false,
            preDrawCallback: function () {
                const parent = $this.CONTAINER_TABLE.parent();

                parent.css('height', $(window).height() - $this.CONTAINER_TABLE.offset().top - 15);
            },
            scrollY: $(window).height() - this.CONTAINER_TABLE.offset().top - 15,
            searching: true,
            paging: false,
            stateSave: false,
            info: false,
            classes: {
                sSortAsc: 'sort-asc sortable-column',
                sSortDesc: 'sort-desc sortable-column',
                sSortable: 'sortable-column',
                sFilterInput: 'border-left-none border-top-none border-bottom-none'
            },
            oLanguage: {
                sSearch: '' +
                '   <div class="border bd-default" style="margin-bottom:10px; overflow:hidden; width:357px">\n' +
                '        <ul class="t-menu horizontal open compact">\n' +
                '            <li data-context="global" style="width:357px">_INPUT_</li>\n' +
                '        </ul>\n' +
                '    </div>',
                sSearchPlaceholder: 'Search...'
            }
        }).on('draw', function () {
            $this._updateButtonState();
        });
    };

    this.eAfterLoad = function () {
        this.children().each(function () {
            $this.initChild(this);
        });
    };

    this.eAfterSelectChild = function (id, options) {
        this._updateButtonState();
    };

    this.eAfterToggleChildSelection = function () {
        this._updateButtonState();
    };

    this.eRemoveChildren = function () {
        this._updateButtonState();
    };

    this.initChild = function (item) {
        (item = $(item)).click(function (event) {
            const selectedChildren = $this.selectedChildren();

            if (event.ctrlKey || event.metaKey || (selectedChildren.length === 1 && selectedChildren.is(item))) {
                $this.toggleChildSelection(item.data('id'));
            } else {
                $this.selectChild(item.data('id'));
            }
        }).disableSelection();

        $(item).addClass('tool-draggable').draggable({
            helper: function () {
                return $('<div id="tool-dragging"></div>').css({
                    width: $(this).attr('data-size-width'),
                    height: $(this).attr('data-size-height')
                });
            },
            distance: 5,
            drag: Editor.ContentList.adjustContainerSize,
            cursorAt: {
                left: 3,
                top: 3
            },
            opacity: 0.7,
            appendTo: Editor.ContentList.CONTAINER_CONTENT
        });
    };

    if (!MadekMediaList.prototype.init) {
        MadekMediaList.prototype = new TableList(init);
        MadekMediaList.prototype.constructor = MadekMediaList;
    }
}

new MadekMediaList();