function TextList(init) {
	var $this = this;

	this.CONTAINER = $('#container-text-view');
	this.CONTAINER_SCROLL = $('.text-list', this.CONTAINER)
	this.CONTAINER_CONTENT = $('.text-list', this.CONTAINER);
	this.CONTAINER_LOADING = $('.container-loading', this.CONTAINER);
	this.BUTTON_TOGGLE_TRACK_CHANGES = $('#toggle-track-changes', this.CONTAINER);
	this.SELECTOR_CHILD = 'li.list-entry';
	this.CLASS_LOADING = 'loading';

	this.load = function() {
		var data = $('<ul/>');

		Editor.ContentList
			.children()
			.filter('[data-tool="text"], [data-tool="simpletext"]')
			.sort(function(a, b) {
				return parseInt($(a).css('z-index')) < parseInt($(b).css('z-index')) ? 1 : -1;
			})
			.each(function(i, item) {
				$this._createChild($(item)).appendTo(data);
			});

		List.prototype._eLoad.call(this, data.html());
	};

	this.eAfterLoad = function() {
		this.children().each(function() {
			$this.initChild($(this));
		});
	}

	this.loadChild = function(id) {
		if (this.child(id).length == 0) {
			this.CONTAINER_CONTENT.prepend('<li class="file loading" data-id="' + id + '"><em>Loading</em></li>');
		}
		List.prototype._eLoadChild.call(this, this._createChild(Editor.ContentList.child(id)));
	};

	this.eAfterLoadChild = function(data) {
		this.initChild(data);
	};

	this.initChild = function(item) {
		var content = $('.content', item);
		$('.button-edit', item).toggle(
			function() {
				Editor.enableHintOnTabClose();

				var textArea = $('<textarea/>').html(content.html());
				content.html(textArea);
				DialogForm.loadTextEditor(textArea);
				$(this).text('save').show();
			},
			function() {
				Editor.disableHintOnTabClose();

				var li = $(this).closest('li'),
					containerLoading = li.children('.container-loading').show();
				$.post('/item/update-text-content', {
					item: item.attr('data-id'),
					research: Editor.getResearchId(),
					textcontent: $('textarea', item).val()
				}, function() {
					containerLoading.hide();
					content.html($('textarea', item).val());
				});
				$(this).text('edit').css('display', '');
			});
		$('.button-up', item).click(function() {
			var prev = item.prev();
			item.insertBefore(prev);
			Editor.LayerList.bringInFrontOf(item.attr('data-id'), prev.attr('data-id'));
		});
		$('.button-down', item).click(function() {
			var next = item.next();
			item.insertAfter(next);
			Editor.LayerList.bringInBackOf(item.attr('data-id'), next.attr('data-id'));
		});
	};

	this.init = function() {
		this.CONTAINER_CONTENT.addClass('track-changes-off');
	};

	this._createChild = function(contentItem) {
		var text = $('.mceContentBody', contentItem),
			lastEdit = '-';
		if (contentItem.data('text-author')) {
			lastEdit = contentItem.data('text-author') + ' ' + contentItem.data('text-modified')
		}
		return $('<li class="list-entry">')
			.html(
				$('<div/>')
					.addClass('content-header')
					.text(contentItem.data('title') + ' - last edit: ' + lastEdit)
					.append($('<button/>').addClass('button button-edit').button().text('edit'))
					.append($('<button/>').addClass('button button-up').button())
					.append($('<button/>').addClass('button button-down').button())
			)
			.attr('data-id', contentItem.data('id'))
			.append($('<div class="content mceContentBody"/>').html(text.html()))
			.append($('<div class="container-loading"></div>').hide());
	};

	this.toggle = function() {
		if (this.CONTAINER.is(':hidden')) {
			this.load();
		} else {
			Editor.ContentList.CONTAINER_LOADING.show();
			Editor.loadItems();
		}
		this.CONTAINER.toggle();
	}

	this.toggleTrackChanges = function() {
		var newText = this.BUTTON_TOGGLE_TRACK_CHANGES.attr('data-toggle-text');
		this.BUTTON_TOGGLE_TRACK_CHANGES.attr('data-toggle-text', this.BUTTON_TOGGLE_TRACK_CHANGES.html()).html(newText);
		if (this.CONTAINER_CONTENT.hasClass('track-changes-on')) {
			this.CONTAINER_CONTENT.addClass('track-changes-off');
			this.CONTAINER_CONTENT.removeClass('track-changes-on');
		} else {
			this.CONTAINER_CONTENT.addClass('track-changes-on');
			this.CONTAINER_CONTENT.removeClass('track-changes-off');
		}
	}

	this.loadIfNecessary = function() {
		if (this.CONTAINER.is(':visible')) {
			this.load();
		}
	}

	if (!TextList.prototype.init) {
		TextList.prototype = new List(init);
		TextList.prototype.constructor = TextList;
	}

	if (init) this.init();
}
new TextList();