Number.is = function () {
    var valid = true;
    for (var i in arguments) {
        valid &= !isNaN(arguments[i]) && parseInt(arguments[i]) == arguments[i];
    }
    return valid;
}

$(document).ajaxError(function (e, xhr, opts) {
    var dialogForm;

    switch ((xhr || {}).status) {
        case 0:
            break;

        case 401:
            dialogForm = new DialogForm({
                zIndex: 99999,
                content: xhr.responseText,
                eInvalidSubmit: function (data) {
                    $('#frm-error', dialogForm.get()).html($(data).children('p').html());
                }
            });
            break;

        default:
            dialogForm = new DialogForm({
                width: '95%',
                zIndex: 99999,
                title: 'An error occurred',
                content: '<div>' + (xhr.responseText || '<i>not available</i>') + '</div>',
                buttons: {
                    Close: function () {
                        dialogForm.getDialog().dialog('close');
                    }
                }
            });
    }
});

function showTitle(target) {
    if ($(target).length == 0 || $(target).is(':hidden')) return;
    if ($('#title').length == 0) {
        $('<div id="title"></div>').appendTo('body');
    }
    $('#title').html($(target).attr('data-title') || '').css({
        top: $(target).offset().top,
        left: $(target).offset().left + $(target).outerWidth()
    });
}

function hideTitle() {
    $('#title').remove();
}

function changeLanguage(obj) {
    var language = $(obj).val();
    var defaultLanguage = $(obj).attr('data-default-language');

    $('p[data-language]', $(obj).closest('div.language-bar').parent()).each(function () {
        $(this).toggle($(this).attr('data-language') == language);
    });

    $('p:not(p[data-language])', $(obj).closest('div.language-bar').parent()).each(function () {
        var elements = $('input', this).add('select', this).add('textarea', this).add('radio', this);
        if (language != defaultLanguage) {
            $(this).addClass('gray');
            elements.attr('disabled', 'disabled');
        } else {
            $(this).removeClass('gray');
            elements.removeAttr('disabled');
        }
    });
}

function tooltip(text, position) {
    return 'data-role="hint" ' +
        'data-hint-position="' + (position || 'top') + '" ' +
        'data-hint-background="bg-black" ' +
        'data-hint-color="fg-white" ' +
        'data-hint-mode="2" ' +
        'data-hint-text="' + text + '" ';
}