function advancedSearchDialog(queryString) {
    var dialogForm = new DialogForm({
        url: '/portal/advanced-search?' + queryString,
        dialog: {
            overflow: 'visible'
        },
        eAfterOpenAsync: function () {
            $('#frm-resulttype').val('research');
        },
        eSubmit: function () {
            var dialog = $(dialogForm.get());
            $('.ui-tabs', dialog).find('.ui-tabs-panel:hidden').remove();

            location.href = '/portal/search-result?' + dialog.serialize();
            dialog.dialog('close');

            return false;
        }
    });
}

function acceptDisapproveDialog(id, type, entityType) {
    new DialogForm({
        url: '/profile-entity/collaborate?entity=' + id + '&decision=acceptDisapprove&type=' + type + '&entity_type=' + entityType
    });
}

function declineDisapproveDialog(id, type, entityType) {
    new DialogForm({
        url: '/profile-entity/collaborate?entity=' + id + '&decision=declineDisapprove&type=' + type + '&entity_type=' + entityType
    });
}

function acceptCollaborationDialog(id, type, entityType) {
    new DialogForm({
        url: '/profile-entity/collaborate?entity=' + id + '&decision=accept&type=' + type + '&entity_type=' + entityType,
        eAfterClose: function () {
            document.location.reload();
        }
    });
}

function declineCollaborationDialog(id, type, entityType) {
    new DialogForm({
        url: '/profile-entity/collaborate?entity=' + id + '&decision=decline&type=' + type + '&entity_type=' + entityType,
        eAfterClose: function () {
            document.location.reload();
        }
    });
}

function leaveCollaborationDialog(id, type) {
    new DialogForm({
        url: '/profile-entity/collaborate?entity=' + id + '&decision=leave&type=' + type,
        reloadOnSuccess: true
    });
}

function portalMembershipRequestDialog(userId, portalId, decision) {
    new DialogForm({
        url: '/profile/portal-membership-request?user=' + userId + '&portal=' + portalId + '&decision=' + decision
    });
}

function addMessageDialog(targetuserid) {
    new DialogForm({
        insertResponseOnSuccess: '#container-content',
        url: '/messenger/add' + (targetuserid ? '?receiverids=' + targetuserid : '')
    });
}

function removeMessageDialog(id) {
    new DialogForm({
        url: '/messenger/remove?message=' + id,
        reloadOnSuccess: true
    });
}

function changeMediaFile($fileField) {
    var $container = $fileField.closest('div');
    $container.show();
    $container.next('.description').hide();
}

function deleteMediaFile($fileField) {
    $('#' + $fileField.attr('id') + '_delete').val("delete");
    $fileField.closest('div').next('.description').html('File will be removed on saving the form.');
}

function toggleFeedFollowing(id, type, element) {
    if (element.attr('data-follow') == '1') {
        unfollowDialog(id, type);
    } else {
        followDialog(id, type);
    }

    var label = element.html();
    element.html(element.attr('data-label'));
    element.attr('data-label', label);
    element.attr('data-follow', +!parseInt(element.attr('data-follow')));
}

function unfollowDialog(id, type) {
    $.post('/feeds/unfollow-' + type + '?' + type + '=' + id);
}

function followDialog(id, type) {
    $.post('/feeds/follow-' + type + '?' + type + '=' + id);
}

function editFeedSettingsDialog() {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/feeds/settings'
    });
}

function showMessageDialog(id) {
    var dialog = new DialogForm({
        url: '/messenger/show?message=' + id,
        width: 600,
        submitSuccess: function (data) {
            if (data) {
                dialog.removeLoadingScreen();
                new DialogForm({
                    content: data
                });
            }
        },
        eAfterClose: function () {
            if (location.href.indexOf('message=') !== -1) {
                location.href = location.pathname;
            } else {
                location.reload();
            }
        }
    });
}

function changePasswordDialog() {
    new DialogForm({
        url: '/profile/change-password'
    });
}

function changePictureDialog() {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile/change-picture'
    });
}

function changeCvDialog() {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile/change-cv'
    });
}

function removeCvDialog() {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile/remove-cv'
    });
}

function editProfileDialog() {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile/edit'
    });
}

function addProjectDialog() {
    new DialogForm({
        reloadOnSuccess: true,
        eAfterOpen: function () {
            initProjectDialog(this);
        },
        url: '/project/add'
    });
}

function addDegreeDialog() {
    new DialogForm({
        insertResponseOnSuccess: '#container-content',
        url: '/degree/add'
    });
}

function addProfileEntity(id) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile-entity/add?entity=' + id,
        eAfterOpen: function () {
            initProjectDialog(this);
        }
    });
}

function editProfileEntity(id) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile-entity/edit?entity=' + id,
        eAfterOpen: function () {
            initProjectDialog(this);
        }
    });
}

function removeProfileEntity(id) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile-entity/remove?entity=' + id
    });
}

function shareProfileEntity(id) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile-entity/share?entity=' + id
    });
}

function publishResearchDialog(id) {
    new DialogForm({
        insertResponseOnSuccess: '#container-content',
        url: '/research/publish?research=' + id
    });
}

function publishApplicationDialog(id) {
    new DialogForm({
        insertResponseOnSuccess: '#container-content',
        url: '/application/publish?application=' + id
    });
}

function selfPublishResearchDialog(id) {
    new DialogForm({
        insertResponseOnSuccess: '#container-content',
        url: '/research/self-publish?research=' + id
    });
}

function connectProfileEntity(id) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile-entity/connect-to-portal?entity=' + id
    });
}

function addResearchDialog() {
    new DialogForm({
        eValidSubmit: function (data) {
            location.href = $('<div/>').html(data).text();
        },
        url: '/research/add'
    });
}

function addApplicationDialog(id) {
    var url = '/application/add';
    if (id) {
        url += '?application-program=' + id;
    }

    new DialogForm({
        reloadOnSuccess: true,
        url: url,
        dialog: {
            width: 1100,
            dialogClass: 'dialog dialog-large'
        },
        eAfterValidSubmit: function () {
            $('.ui-dialog').remove();
        }
    });
}

function editApplicationDialog(id) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/application/edit?application=' + id,
        dialog: {
            width: 1100,
            dialogClass: 'dialog dialog-large'
        }
    });
}

function addWorkDialog() {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/work/add-profile'
    });
}

function editWorkDialog(workId) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile-entity/edit?entity=' + workId
    });
}

function removeWorkDialog(workId) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/work/remove?work=' + workId
    });
}

function shareWorkDialog(id) {
    new DialogForm({
        insertResponseOnSuccess: '#container-content',
        url: '/work/share?work=' + id
    });
}


function addFileToWorkDialog(workId, context) {
    new DialogForm({
        url: '/work/add-file?work=' + workId,
        eAfterValidSubmit: function () {
            var tabContainer = $(context).closest('.ui-tabs');
            tabContainer.tabs('load', tabContainer.tabs('option', 'active'));
        }
    });
}

function addSnapshot(id, context) {
    new DialogForm({
        url: '/snapshot/add?research=' + id,
        eAfterValidSubmit: function () {
            var tabContainer = $(context).closest('.ui-tabs');
            tabContainer.tabs('load', tabContainer.tabs('option', 'active'));
        }
    });
}

function restoreSnapshot(id, context) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/snapshot/restore?snapshot=' + id,
        eAfterValidSubmit: function () {
            $('.ui-dialog').remove();
        }
    });
}

function removeSnapshot(id, context) {
    new DialogForm({
        url: '/snapshot/remove?snapshot=' + id,
        eAfterValidSubmit: function () {
            var tabContainer = $(context).closest('.ui-tabs');
            tabContainer.tabs('load', tabContainer.tabs('option', 'active'));
        }
    });
}

function uploadFileToProfileEntity(id, context) {
    new DialogForm({
        url: '/profile-entity/file-upload?entity=' + id,
        eAfterValidSubmit: function () {
            var tabContainer = $(context).closest('.ui-tabs');
            tabContainer.tabs('load', tabContainer.tabs('option', 'active'));
        }
    });
}

function updateProfileEntityThumb(id, fileId) {
    $.post('/profile-entity/update-thumb?entity=' + id + '&file=' + fileId);
}

function editFileOfProfileEntity(id, context) {
    new DialogForm({
        url: '/file/edit?file=' + id,
        eAfterValidSubmit: function () {
            var tabContainer = $(context).closest('.ui-tabs');
            tabContainer.tabs('load', tabContainer.tabs('option', 'active'));
        }
    });
}

function removeFileFromProfileEntity(id, context) {
    new DialogForm({
        url: '/profile-entity/file-remove?file=' + id,
        eAfterValidSubmit: function () {
            var tabContainer = $(context).closest('.ui-tabs');
            tabContainer.tabs('load', tabContainer.tabs('option', 'active'));
        }
    });
}

function importResearchDialog() {
    new DialogForm({
        eValidSubmit: function (data) {
            location.href = $('<div/>').html(data).text();
        },
        url: '/research/import'
    });
}

function versioning(id) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile-entity/versioning?entity=' + id
    });
}

function addShortcut(entityId) {
    $.post('/profile/add-shortcut?entity=' + entityId, function () {
        location.reload();
    });
}

function removeShortcut(entityId) {
    $.post('/profile/remove-shortcut?entity=' + entityId, function () {
        location.reload();
    });
}

function changeLayout(entityId) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/profile-entity/change-layout?entity=' + entityId
    });
}

function openMenu(menu, element) {
    if (menu.is(':visible')) {
        return;
    }
    $(document).one('click', function () {
        $(document).one('click', function () {
            menu.hide();
        });
    });
    menu.appendTo('body')
        .css({
            left: $(element).offset().left,
            top: $(element).offset().top
        })
        .show();
}

function editResearchDialog(id) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/research/edit?research=' + id
    });
}

function republishResearchDialog(id) {
    new DialogForm({
        reloadOnSuccess: true,
        url: '/research/republish?research=' + id
    });
}

function toggleDisplay(selector) {
    $(selector).toggle();
}

function setSearchFilter(obj, value) {
    $('#search-filter').val(value);
    $('a', $(obj).parent()).removeClass('advanced-search-filter-active');
    $(obj).addClass('advanced-search-filter-active');
}

function loginAction(form) {
    $.post(form.action, $(form).serialize(), function (data, b, xhr) {
        if (data) {
            new DialogForm({
                content: data,
                dialog: {
                    buttons: {
                        Ok: function () {
                            $(this).dialog('close');
                        }
                    }
                }
            });
        } else if (location.href.search(/portal$/i) != -1 || (location.href.substr(location.href.length - 1, 1) == '/' && location.href.split('/').length <= 4)) {
            location.href = '/profile';
        } else {
            location.reload();
        }
    });

    return false;
}

function addCommentDialog(id) {
    new DialogForm({
        url: '/comment/add?research=' + id,
        insertResponseOnSuccess: $('#container-comment-' + id).parent(),
        eAfterValidSubmit: function () {
            $('#container-comment-' + id).show();
        }
    });
}

function removeCommentDialog(id, researchId) {
    new DialogForm({
        url: '/comment/remove?comment=' + id,
        insertResponseOnSuccess: $('#container-comment-' + researchId).parent(),
        eAfterValidSubmit: function () {
            if (document.location.pathname == '/admin') {
                document.location.reload();
            }
            $('#container-comment-' + researchId).show();
        }
    });
}

function convertCommentDialog(id) {
    new DialogForm({
        url: '/comment/convert?comment=' + id,
        reloadOnSuccess: true
    });
}

function addReportDialog(researchId, portalId) {
    new DialogForm({
        url: '/report/add?research=' + researchId + '&portal=' + portalId,
        insertResponseOnSuccess: $('#container-report-' + researchId + '-' + portalId).parent(),
        eAfterValidSubmit: function () {
            $('#container-report-' + researchId + '-' + portalId).show();
        }
    });
}

function removeReportDialog(id, researchId, portalId) {
    new DialogForm({
        url: '/report/remove?report=' + id,
        insertResponseOnSuccess: $('#container-report-' + researchId + '-' + portalId).parent(),
        eAfterValidSubmit: function () {
            if (document.location.pathname == '/admin') {
                document.location.reload();
            }
            $('#container-report-' + researchId).show();
        }
    });
}

function convertReportDialog(id) {
    new DialogForm({
        url: '/report/convert?report=' + id,
        reloadOnSuccess: true
    });
}

function togglePublishState(obj) {
    var radio = $(obj);
    var form = radio.closest('form');
    $(':radio', form).attr('checked', false);
    radio.attr('checked', true);

    $('select', form).attr('disabled', 'disabled');
    if (radio.attr('name').indexOf('submitto') !== -1) {
        $('select', radio.closest('p').next()).removeAttr('disabled');
    }
}

function toggleDescription() {
    $('.content-profile-description').each(function () {
        $(this).ThreeDots({max_rows: 1});
    });
}

function initMessenger() {
    $('[type=checkbox][value=all]').click(function () {
        var checked = $(this).prop('checked');
        $(this).closest('table').find('[type=checkbox]').prop('checked', checked);
    });
    $('.messenger-action').change(function () {
        var messageIds = [];
        var messengerAction = $(this);
        messengerAction.closest('table').find('[type=checkbox]:checked').each(function () {
            if (!$(this).val().match(/\d+/)) {
                return;
            }

            messageIds.push($(this).val());
        });

        if (messageIds.length == 0) {
            $(this).val('');
            return;
        }

        if (messengerAction.val() == 'read') {
            new DialogForm({
                url: '/messenger/read-selected',
                data: {
                    message: messageIds
                },
                reloadOnSuccess: true,
                eBeforeValidSubmit: function () {
                    messengerAction.closest('table').find('[type=checkbox]:checked').each(function () {
                        $(this).prop('checked', false);
                    });
                    messengerAction.val('');
                }
            });
        } else if (messengerAction.val() == 'delete') {
            new DialogForm({
                url: '/messenger/remove-selected',
                data: {
                    message: messageIds
                },
                reloadOnSuccess: true,
                eBeforeValidSubmit: function () {
                    messengerAction.closest('table').find('[type=checkbox]:checked').each(function () {
                        $(this).prop('checked', false);
                    });
                    messengerAction.val('');
                }
            });
        }
    });
}

function lazyLoadMedias() {
    $('.research-image-container[data-id]:visible').each(function () {
        $(this).load('/profile-entity/media?entity=' + $(this).attr('data-id'), function (content) {
            if (!content) {
                $(this).remove();
            }
        });
        $(this).removeAttr('data-id');
    });
}

function addGroupingDialog() {
    new DialogForm({
        url: '/profile/add-group',
        reloadOnSuccess: true
    });
}

function initProjectDialog(form) {
    var select = $('#frm-meta-mainfieldofstudytype', form.DIALOG_FORM),
        input = $('#frm-meta-mainfieldofstudy', form.DIALOG_FORM),
        inputContainer = input.parent().toggle(select.val() == 'other');

    select.bind('change', function () {
        if (select.val() == 'other') {
            if ($('option[value="' + input.val() + '"]', select).length == 1) {
                input.val('');
            }
            inputContainer.show();
        } else {
            input.val(select.val());
            inputContainer.hide();
        }
    }).trigger('change');

    $('<img data-title="60 credits are equivalent to 1 year of full-time study." class="info" src="/rc/images/information.png">')
        .bind('mouseout', hideTitle)
        .bind('mouseover', function () {
            showTitle(this)
        })
        .insertAfter('#frm-meta-ects');
}

function addNavigateBackMenuEntry() {
    if (history.length == 1) {
        return;
    }
    $('.meta-header').append('<span class="meta-header-spacer">|</span><a href="#" onclick="history.back();return false">back to previous page</a>');
}

function updateFilePosition(fileId, entityId, position, element) {
    $.post(
        '/profile-entity/update-file-position',
        {file: fileId, entity: entityId, position: position}
    );

    if (typeof element === 'undefined') {
        return;
    }

    $(element).closest('.files-entry').insertBefore($('.files-entry').get(position));

    $('.files-entry select').each(function (key) {
        $(this).val(key);
    });
}

function initObjectViewer(container) {
    if (container.css('cursor') == 'move') {
        return;
    }

    var objectViewer = new ObjectViewer(container, {
        levels: container.attr('data-levels'),
        startimage: container.attr('data-start-image'),
        rotomatic: container.attr('data-auto-rotate') == '1' ? 80 : 0,
        images: container.attr('data-resources').split(',')
    });

    $(document)
        .bind('mousedown.objectviewer', function (event) {
            if ($(event.target).attr('id') == container.attr('id')) {
                return;
            }

            objectViewer.unload();
            delete(objectViewer);
            container.css('cursor', 'pointer');
        })
        .bind('keyup.objectviewer', function (event) {
            if (event.keyCode != 27) {
                return;
            }

            objectViewer.unload();
            delete(objectViewer);
            container.css('cursor', 'pointer');
        });

    container.css('cursor', 'move');
}

function reviewApplication(id) {
    var dialog = new DialogForm({
        url: '/application/review?application=' + id,
        closeOnSuccess: false,
        eAfterValidSubmit: function (data, b, xhr, formData) {
            var submitButton = formData.pop().name;
            if (submitButton === 'savebutton') {
                document.location.reload();
                return;
            }

            new DialogForm({
                url: '/application/submit-review?application=' + id,
                reloadOnSuccess: true,
                eBeforeClose: function () {
                    dialog.eClose();
                }
            });
        },
        dialog: {
            width: 1100,
            dialogClass: 'dialog dialog-large'
        }
    });
}

function editMembershipDialog() {
    new DialogForm({
        url: 'profile/portal-membership-edit',
        reloadOnSuccess: true
    });
}

function requestMembershipDialog(portal) {
    $.post('/portals/request-membership?portal=' + portal);
}

function initExpositionEditorType(selector) {
    const context = $(selector).closest('form');

    $('#frm-meta-editortype', context)
        .bind('change', function () {
            $('#frm-meta-template', context).parent().toggle($(this).val() === 'text-based');
        })
        .trigger('change');
}

function resendConfirmationMail(element) {
    $.post('/portal/confirm-email', function () {
        $(element).parent().html('Confirmation mail sent! Please check your inbox.').css('color', 'green');
    });

}

$(function () {
    jwplayer.key = "SeIeABotC08750h3V7r77b550BnnaXah0rvcdaFiL6U=";

    $('.content-navigation').append(
        $('<a href="#" class="icon">☰</a>').bind('click', function () {
            const navigation = $('.content-navigation'),
                header = $('#header');

            if (!navigation.hasClass('responsive')) {
                navigation.addClass('responsive');
                header.css('borderBottomColor', 'transparent');
            } else {
                navigation.removeClass('responsive');
                header.css('borderBottomColor', '#000');
            }

            return false;
        })
    )
});
