<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

$baseUri = config('app.url');

return [
    'message.mail.placeholder'                          => '<i>This action cannot be performed in emails. Please click <a href="' . $baseUri . '/messenger?message=%s" target="_blank">here</a></i>.',
    'message.subject.task.add'                          => 'new task',
    'message.subject.review.new.research'               => 'new research to review',
    'message.subject.review.new.application'            => 'review request',
    'message.subject.approve.new.newsletter'            => 'newsletter waiting for approvement',
    'message.subject.submit.to.portal'                  => 'submission request',
    'message.subject.submission.accepted'               => 'submission accepted',
    'message.subject.submission.declined'               => 'submission declined',
    'message.subject.application.accepted'              => 'application accepted',
    'message.subject.application.declined'              => 'application declined',
    'message.subject.application.submitted'             => 'application submitted',
    'message.subject.application.forwarded'             => 'application forwarded',
    'message.subject.application.reviewmail'            => 'Reviews for "%s" by %s',
    'message.subject.partof.request'                    => 'portal connection request',
    'message.subject.partof.accepted'                   => 'portal connection accepted',
    'message.subject.partof.declined'                   => 'portal connection declined',
    'message.subject.media.transcoded'                  => 'media file transcoded',
    'message.subject.portal.add'                        => 'membership request',
    'message.subject.collaboration.admin.add'           => 'collaboration',
    'message.subject.collaboration.admin.remove'        => 'collaboration terminated',
    'message.subject.collaboration.add'                 => 'invitation for collaboration',
    'message.subject.collaboration.add.supervisor'      => 'invitation to supervise',
    'message.subject.collaboration.add.advisor'         => 'invitation to advise',
    'message.subject.collaboration.add.coauthor'        => 'invitation to co-author',
    'message.subject.collaboration.add.contributor'     => 'invitation to contribute',
    'message.subject.collaboration.remove'              => 'collaboration terminated',
    'message.subject.collaboration.disapprove'          => 'collaboration terminated',
    'message.subject.collaboration.cancel'              => 'invitation for collaboration canceled',
    'message.subject.collaboration.accept'              => 'invitation for collaboration accepted',
    'message.subject.collaboration.decline'             => 'invitation for collaboration declined',
    'message.subject.collaboration.leave'               => 'collaboration left',
    'message.subject.account.confirm'                   => 'Confirm your email address',
    'message.content.task.add'                          => 'Hello %s,<br/><br/>%s has assigned you a new task in the research <a href="' . $baseUri . '/editor?research=%s&weave=%s">"%s"</a> which should be solved until %s.<br/><br/>Task:<br/>%s',
    'message.content.review.new.research'               => 'Hello %s,<br/><br/>you have to review the research "%s" for the portal "%s". You can find all researches for reviewing <a href="' . $baseUri . '/review">here</a>.',
    'message.content.review.new.application'            => 'Hello %s,<br/><br/>you have to review the application "%s" for the portal "%s". You can find all applications for reviewing <a href="' . $baseUri . '/profile/show-application?application=%s">here</a>.',
    'message.content.approve.new.newsletter'            => 'Hello %s,<br/><br/>you have to approve the newsletter "%s" for the portal "%s". You can find all newsletter waiting for approvement <a href="' . $baseUri . '/admin/portal/list">here</a>.',
    'message.content.media.transcoded'                  => 'Hello %s,<br/><br/>the media files for the object "%s" have been transcoded and are available now.',
    'message.content.portal.add'                        => 'Hello %s,<br/><br/>the user "%s" has requested a membership for "%s". Click below to either accept or decline this request.<br/><br/>
        <div style="text-align:center">
            <a href="javascript:portalMembershipRequestDialog(%4$s,%5$s,\'accept\')">accept</a>
            <a href="javascript:portalMembershipRequestDialog(%4$s,%5$s,\'decline\')">decline</a>
        </div><br/>',
    'message.content.submit.to.portal'                  => 'Hello %s,<br/><br/>%s has submitted the %s "%s" to portal "%s". <a href="' . $baseUri . '/admin/%s/list?context=%s" target="_blank">See more</a>',
    'message.content.partof.request'                    => 'Hello %s,<br/><br/>%s wants to add the %s "%s" to portal "%s". <a href="' . $baseUri . '/admin/research/list?context=%s" target="_blank">See more</a>',
    'message.content.partof.accepted'                   => 'Hello %s,<br/><br/>the portal "%s" has added your %s "%s".',
    'message.content.partof.declined'                   => 'Hello %s,<br/><br/>the portal "%s" has declined your portal connection request for the %s "%s".',
    'message.content.submission.accepted'               => 'Hello %s,<br/><br/>the portal "%s" has published your %s "%s".',
    'message.content.submission.declined'               => 'Hello %s,<br/><br/>the portal "%s" has declined your submission of the %s "%s".',
    'message.content.application.accepted'              => 'Hello %s,<br/><br/>the portal "%s" has published your %s "%s".',
    'message.content.application.declined'              => 'Hello %s,<br/><br/>the portal "%s" has declined your submission of the %s "%s".',
    'message.content.application.forwarded'             => 'Hello %s,<br/><br/>your application "%s" has been forwarded to ""%s". You can find application details under %s.',
    'message.content.collaboration.admin.add'           => 'Hello %s,<br/><br/>the administrator %s has added you to the %s "<b>%s</b>" as "<b>%5$s</b>".',
    'message.content.collaboration.admin.remove'        => 'Hello %s,<br/><br/>the administrator %s has removed you as "<b>%5$s</b>" from the %s "%s".',
    'message.content.collaboration.add'                 => 'Hello %s,<br/><br/>
		the artist %s has invited you to collaborate in the %s "<b>%s</b>" as "<b>%6$s</b>". Click below to either accept or decline this invitation.<br/><br/>
        <div style="text-align:center">
            <a href="javascript:acceptCollaborationDialog(%5$s,\'%6$s\',\'%3$s\')">accept</a>
            <a href="javascript:declineCollaborationDialog(%5$s,\'%6$s\',\'%3$s\')">decline</a>
        </div><br/>',
    'message.content.collaboration.add.editor'          => 'Hello %s,<br/><br/>
		you have been invited to edit the exposition "<b>%s</b>". Click below to either accept or decline this invitation.<br/><br/>
        <div style="text-align:center">
            <a href="javascript:acceptCollaborationDialog(%5$s,\'%6$s\',\'%3$s\')">accept</a>
            <a href="javascript:declineCollaborationDialog(%5$s,\'%6$s\',\'%3$s\')">decline</a>
        </div><br/>',
    'message.content.collaboration.remove'              => 'Hello %s,<br/><br/>the artist %s has terminated the collaboration for the %s "%s".',
    'message.content.collaboration.disapprove.accepted' => 'Hello %s,<br/><br/>the artist %s has left the role "supervisor" for "%s".',
    'message.content.collaboration.disapprove.declined' => 'Hello %s,<br/><br/>the artist %s has declined to leave the role "supervisor" for "%s".',
    'message.content.collaboration.disapprove'          => 'Hello %s,<br/><br/>the artist %s would like to revoke your access as %6$s to the %3$s "%4$s". You need to press "accept" for this to take effect.
        If you press "decline" your access to the %s will remain as it is.<br/><br/>
        <div style="text-align:center">
            <a href="javascript:acceptDisapproveDialog(%5$s,\'%6$s\',\'%3$s\')">accept</a>
            <a href="javascript:declineDisapproveDialog(%5$s,\'%6$s\',\'%3$s\')">decline</a>
        </div><br/>',
    'message.content.collaboration.cancel'              => 'Hello %s,<br/><br/>the artist %s has cancelled the collaboration-invitation for the %s "%s".',
    'message.content.collaboration.accept'              => 'Hello %s,<br/><br/>the artist %s has accepted your collaboration-invitation for the %s "%s".',
    'message.content.collaboration.decline'             => 'Hello %s,<br/><br/>the artist %s has declined the collaboration-invitation for the %s "%s".',
    'message.content.collaboration.leave'               => 'Hello %s,<br/><br/>the artist %s has left the collaboration for the %s "%s".',
    'message.subject.forgotten.password'                => 'password forgotten',
    'message.content.forgotten.password.text'           => 'Hello %s,\n\nyou receive this email because you have forgotten your password. Please click on the following link to change your password. The link is valid only for one time.\n\nlink: ' . $baseUri . '/portal/change-password?key=%s \n\nSincerely,\nyour Research Catalogue',
    'message.content.forgotten.password.html'           => 'Hello %s,<br/><br/>you receive this email because you have forgotten your password. Please click on the following link to change your password. The link is valid only for one time.<br/><br/><a href="' . $baseUri . '/portal/change-password?key=%s" target="_blank">Change Password</a><br/><br/>Sincerely,<br/>your Research Catalogue',
    'message.subject.unread.message'                    => 'RC unread message: %s from %s',
    'message.content.unread.message.html'               => 'Hello %s,<br/><br/>you have a new unread message from %s. <div style="border-bottom:1px solid black;margin:10px 0"></div>%s<div style="border-bottom:1px solid black;margin:10px 0"></div><a href="' . $baseUri . '/messenger?message=%s" target="_blank">click here to reply</a>',
    'message.content.research.update.inprogress'        => 'Dear Administrators, a new feature is being implemented:<br/>%s',
    'message.content.research.update.terminated'        => 'Dear Administrators, a new feature has been implemented:<br/>%s',
    'message.content.application.submitted'             => 'Hello %s,<br/><br/>"%s" has been submitted to portal "%s".',
    'message.content.account.confirm'                   => 'Hello %s,<br/><br/>you receive this email because you created an account on the Research Catalogue. Please click below to confirm your email address:<br/><br/><a href="%s">Confirm email address</a><br/><br/>Sincerely,<br/>your Research Catalogue',
];

?>