<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Application;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use JMS\Serializer\Annotation as ODS;
use Rc\Domain\Model\AbstractModel;
use Rc\Domain\Model\User;

/**
 * @ODM\Document
 */
class ApplicationFavorite extends AbstractModel
{

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $label;

    /**
     * @var ApplicationProgram
     * @ODM\ReferenceOne(targetDocument="Rc\Domain\Model\Application\ApplicationProgram", storeAs="dbRef")
     */
    protected $program;

    /**
     * @var User
     * @ODM\ReferenceOne(targetDocument="Rc\Domain\Model\User", storeAs="dbRef")
     * @ODS\Type(name="Rc\Serializer\Type\Owner")
     */
    protected $owner;

    /**
     * @var array
     * @ODM\Field(type="hash")
     */
    protected $selection = [];

    /**
     * @return string
     */
    public function getLabel()
    {
        return $this->label;
    }

    /**
     * @param string $label
     */
    public function setLabel($label)
    {
        $this->label = $label;
    }

    /**
     * @return ApplicationProgram
     */
    public function getProgram()
    {
        return $this->program;
    }

    /**
     * @param ApplicationProgram $program
     */
    public function setProgram($program)
    {
        $this->program = $program;
    }

    /**
     * @return mixed
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * @param mixed $owner
     */
    public function setOwner($owner)
    {
        $this->owner = $owner;
    }

    /**
     * @return array
     */
    public function getSelection()
    {
        return $this->selection;
    }

    /**
     * @param array $selection
     */
    public function setSelection($selection)
    {
        $this->selection = $selection;
    }

}
