<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Application\Form\FormElement;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Application\Form\FormElement;

/**
 * @ODM\EmbeddedDocument
 */
class ImageFormElement extends FormElement
{

    const FORM_TYPE = 'file';

    /**
     * @inheritDoc
     */
    public function getFormOptions()
    {
        $options = [
            'validators' => [
                'IsImage',
            ],
        ];
        return $options + parent::getFormOptions();
    }

    /**
     * @return bool
     */
    public function requiresUpload()
    {
        return true;
    }

}