<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Application\Form\FormElement;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;

/**
 * @ODM\EmbeddedDocument
 */
class PdfFormElement extends FileFormElement
{
    /**
     * @inheritDoc
     */
    public function getFormOptions()
    {
        $options = [
            'validators' => [
                ['MimeType', false, ['application/pdf', 'application/x-pdf']],
            ],
        ];
        return $options + parent::getFormOptions();
    }
}