<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Application\Form\FormElement;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Application\Form\FormElement;

/**
 * @ODM\EmbeddedDocument
 */
class RangeFormElement extends FormElement
{
    const FORM_TYPE = 'range';

    /**
     * @var int
     * @ODM\Field(type="integer")
     */
    protected $min;

    /**
     * @var int
     * @ODM\Field(type="integer")
     */
    protected $max;

    /**
     * @return int
     */
    public function getMin()
    {
        return $this->min;
    }

    /**
     * @param int $min
     */
    public function setMin($min)
    {
        $this->min = $min;
    }

    /**
     * @return int
     */
    public function getMax()
    {
        return $this->max;
    }

    /**
     * @param int $max
     */
    public function setMax($max)
    {
        $this->max = $max;
    }

    /**
     * @inheritDoc
     */
    public function getFormOptions()
    {
        $options = [
            'step'   => 1,
            'min'    => $this->min,
            'max'    => $this->max,
            'update' => true,
        ];
        return $options + parent::getFormOptions();
    }
}