<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Application\Form\FormElement;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Application\Form\FormElement;

/**
 * @ODM\EmbeddedDocument
 */
class ShortTextFormElement extends FormElement
{
    const FORM_TYPE = 'text';

    /**
     * @inheritDoc
     */
    public function getFormOptions()
    {
        $options = [
            'validators' => [
                ['StringLength', false, [0, 200]],
            ],
        ];
        return $options + parent::getFormOptions();
    }

}