<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Application\Form\FormElement;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Application\Form\FormElement;

/**
 * @ODM\EmbeddedDocument
 */
class TextFormElement extends FormElement
{
    const FORM_TYPE = 'textarea';

    /**
     * @var integer
     * @ODM\Field(type="integer")
     */
    protected $max;

    /**
     * @return int
     */
    public function getMax()
    {
        return $this->max;
    }

    /**
     * @param int $max
     */
    public function setMax($max)
    {
        $this->max = $max;
    }

    /**
     * @inheritDoc
     */
    public function getFormOptions()
    {
        $options = [
            'data-autogrow' => '1',
            'validators' => [
                [
                    'StringLength',
                    false,
                    [0, $this->max],
                ],
            ],
        ];
        return $options + parent::getFormOptions();
    }

}