<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Application\Form;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;

/**
 * @ODM\EmbeddedDocument
 */
abstract class LayoutElement extends Element
{
    const FORM_TYPE = 'html';

    /**
     * @return array
     */
    public static function getElements()
    {
        return [
            'headline'    => 'layout-element.headline',
            'description' => 'layout-element.description',
            'hr'          => 'layout-element.hr',
        ];
    }

    /**
     * @return string
     */
    public function getName()
    {
        $parts = explode('\\', get_called_class());
        return strtolower(substr(end($parts), 0, -13));
    }

}