<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Application\Generic;

use Rc\Domain\Model\Application\Form\FormElementValueContainer;

interface MetaDataAwareInterface
{
    const KEY_IDENTIFIER_DEFAULT = 'default';
    const KEY_IDENTIFIER_LABEL = 'label';

    /**
     * @param bool $asArray
     * @return FormElementValueContainer[]
     */
    public function getMetaData($asArray = true);

    /**
     * @param string $keyIdentifier
     * @return array
     */
    public function getFormattedMetaData($keyIdentifier = self::KEY_IDENTIFIER_DEFAULT);

    /**
     * @param array $metaData
     * @param bool $preserveFiles
     */
    public function setMetaData(array $metaData, $preserveFiles = true);

    /**
     * @param string $identifier
     * @return null|string
     */
    public function getLabelForIdentifier($identifier);
}
