<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Core\Acl;

use Rc\Domain\Model\User;
use Rc\Domain\Repository\UserRepository;

class AclHelper
{

    /**
     * @param string $group
     * @param int[] $users
     */
    public static function addUserGroup($group, array $users)
    {
        /** @var User[] $dirtyUsers */
        $dirtyUsers = array_filter(UserRepository::findByIds($users), function (User $user) use ($group) {
            if ($user->hasGroup($group)) {
                return false;
            }

            $user->addGroup($group);
            return true;
        });

        UserRepository::persistCollection($dirtyUsers, false);
    }

    /**
     * @param string $group
     * @param int[] $users
     */
    public static function removeUserGroup($group, array $users)
    {
        /** @var User[] $dirtyUsers */
        $dirtyUsers = array_filter(UserRepository::findByIds($users), function (User $user) use ($group) {
            if (!$user->hasGroup($group)) {
                return false;
            }

            $user->removeGroup($group);
            return true;
        });

        UserRepository::persistCollection($dirtyUsers, false);
    }
}
