<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Generic;

trait KeywordAwareTrait
{
    /**
     * @var array
     * @ODM\Field(type="collection")
     */
    protected $keywords = [];

    /**
     * @return array
     */
    public function getKeywordList()
    {
        return $this->keywords;
    }

    /**
     * @return string
     */
    public function getKeywords()
    {
        return implode(', ', $this->keywords);
    }

    /**
     * @param string $keywords
     */
    public function setKeywords($keywords)
    {
        $this->keywords = [];
        foreach (explode(',', $keywords) as $keyword) {
            $keyword = trim($keyword);
            if ($keyword !== '') {
                $this->keywords[] = $keyword;
            }
        }
    }
}