<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;

/**
 * @ODM\Document
 * @ODM\UniqueIndex(keys={"referenceUuid"="asc", "referenceType"="asc"})
 * @ODM\UniqueIndex(keys={"referenceId"="asc", "referenceType"="asc"})
 */
class IdMapping extends AbstractModel
{
    /**
     * @var int
     */
    protected $id = false;

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $referenceType;

    /**
     * @var int
     * @ODM\Field(type="integer")
     */
    protected $referenceId;

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $referenceUuid;

    public function __construct($type, $id, $uuid)
    {
        parent::__construct();
        $this->referenceType = $type;
        $this->referenceId = $id;
        $this->referenceUuid = $uuid;
    }

    /**
     * @return string
     */
    public function getReferenceType()
    {
        return $this->referenceType;
    }

    /**
     * @param string $referenceType
     * @return void
     */
    public function setReferenceType($referenceType)
    {
        $this->referenceType = $referenceType;
    }

    /**
     * @return int
     */
    public function getReferenceId()
    {
        return $this->referenceId;
    }

    /**
     * @param int $referenceId
     * @return void
     */
    public function setReferenceId($referenceId)
    {
        $this->referenceId = $referenceId;
    }

    /**
     * @return string
     */
    public function getReferenceUuid()
    {
        return $this->referenceUuid;
    }

    /**
     * @param string $referenceUuid
     * @return void
     */
    public function setReferenceUuid($referenceUuid)
    {
        $this->referenceUuid = $referenceUuid;
    }
}