<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Media;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\MediaInterface;
use Rc\Domain\Model\Research\MediaContainerAwareInterface;

interface MediaAwareInterface extends MediaContainerAwareInterface
{

    /**
     * @return boolean
     */
    public function hasThumb();

    /**
     * @return MediaInterface
     */
    public function getThumb();

    /**
     * @param MediaInterface $thumb
     */
    public function setThumb(MediaInterface $thumb = null);

    /**
     * @return boolean
     */
    public function hasMedia();

    /**
     * @return MediaInterface
     */
    public function getMedia();

    /**
     * @param MediaInterface $media
     */
    public function setMedia(MediaInterface $media = null);

    /**
     * @param MediaInterface[] $mediaList
     */
    public function setMediaList(array $mediaList);

    /**
     * @return MediaInterface[]
     */
    public function getMediaList();

    /**
     * @return Dimension
     */
    public function getMediaResolution();

}