<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\SimpleMedia;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\Generic\TextAwareInterface;
use Rc\Domain\Model\Research\Exposition\SimpleMedia;

/**
 * @ODM\Document
 */
class TextSimpleMedia extends SimpleMedia implements TextAwareInterface
{

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $text;

    /**
     * @return string
     */
    public function getTextContent()
    {
        return $this->text;
    }

    /**
     * @param string $text
     */
    public function setTextContent($text)
    {
        $this->text = $text;
    }

    /**
     * @return string|null
     */
    public function getMediaType()
    {
        return 'text';
    }

}