<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Research\Exposition\TableOfContent\Anchor;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\TableOfContent\Anchor;

/**
 * @ODM\EmbeddedDocument()
 */
class Point extends Anchor
{

    /**
     * @var int
     * @ODM\Field(type="integer");
     */
    protected $x;

    /**
     * @var int
     * @ODM\Field(type="integer");
     */
    protected $y;

    /**
     * @param int $x
     * @param int $y
     */
    public function __construct($x, $y)
    {
        $this->x = $x;
        $this->y = $y;
    }

    /**
     * @return int
     */
    public function x()
    {
        return $this->x;
    }

    /**
     * @return int
     */
    public function y()
    {
        return $this->y;
    }

    /**
     * @return array
     */
    public function toArray()
    {
        return ['coordx' => $this->x, 'coordy' => $this->y];
    }
}