<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Generic;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\SimpleMedia\AudioSimpleMedia;
use Rc\Domain\Model\Research\Exposition\SimpleMediaInterface;

interface AudioAwareInterface
{

    /**
     * @param SimpleMediaInterface $parent
     * @param AudioSimpleMedia|null $audio
     */
    public function setAudio(SimpleMediaInterface $parent, AudioSimpleMedia $audio = null);

    /**
     * @param SimpleMediaInterface $parent
     * @return bool
     */
    public function hasAudio(SimpleMediaInterface $parent);

    /**
     * @param SimpleMediaInterface $parent
     * @return AudioSimpleMedia|null
     */
    public function getAudio(SimpleMediaInterface $parent);

    /**
     * @param SimpleMediaInterface $parent
     * @return null
     */
    public function getAudioId(SimpleMediaInterface $parent);

    /**
     * @return AudioSimpleMedia[]
     */
    public function getAudios();
}