<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Generic;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\Weave\Style\BorderStyle;

trait BorderAwareTrait
{

    /**
     * @var BorderStyle
     * @ODM\EmbedOne(targetDocument="Rc\Domain\Model\Research\Exposition\Weave\Style\BorderStyle")
     */
    protected $border;

    /**
     * @return array
     */
    public static function getBorderStyles()
    {
        return [
            BorderAwareInterface::CSS_BORDER_NONE => 'css.border.none',
            'solid'                               => 'css.border.solid',
            'dashed'                              => 'css.border.dashed',
            'dotted'                              => 'css.border.dotted',
            'outset'                              => 'css.border.outset',
            'double'                              => 'css.border.double',
            'groove'                              => 'css.border.groove',
            'ridge'                               => 'css.border.ridge',
            'inset'                               => 'css.border.inset',
        ];
    }

    /**
     * @return string
     */
    public function getBorderStyle()
    {
        return $this->border->getStyle();
    }

    /**
     * @param string $style
     */
    public function setBorderStyle($style)
    {
        $this->border->setStyle($style);
    }

    /**
     * @return string
     */
    public function getBorderColor()
    {
        return $this->border->getColor();
    }

    /**
     * @param string $color
     */
    public function setBorderColor($color)
    {
        $this->border->setColor($color);
    }

    /**
     * @return string
     */
    public function getBorderWidth()
    {
        return $this->border->getWidth();
    }

    /**
     * @param string $width
     */
    public function setBorderWidth($width)
    {
        $this->border->setWidth($width);
    }

    /**
     * @return string
     */
    public function getBorderRadius()
    {
        return $this->border->getRadius();
    }

    /**
     * @param string $radius
     */
    public function setBorderRadius($radius)
    {
        $this->border->setRadius($radius);
    }
}