<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Generic;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\Weave\Style\PositionStyle;

trait MarginAwareTrait
{
    /**
     * @var PositionStyle
     * @ODM\EmbedOne(targetDocument="Rc\Domain\Model\Research\Exposition\Weave\Style\PositionStyle")
     */
    protected $margin;

    /**
     * @return int
     */
    public function getMarginTop()
    {
        return $this->margin->getTop();
    }

    /**
     * @param int $marginTop
     */
    public function setMarginTop($marginTop)
    {
        $this->margin->setTop($marginTop);
    }

    /**
     * @return int
     */
    public function getMarginRight()
    {
        return $this->margin->getRight();
    }

    /**
     * @param int $marginRight
     */
    public function setMarginRight($marginRight)
    {
        $this->margin->setRight($marginRight);
    }

    /**
     * @return int
     */
    public function getMarginBottom()
    {
        return $this->margin->getBottom();
    }

    /**
     * @param int $marginBottom
     */
    public function setMarginBottom($marginBottom)
    {
        $this->margin->setBottom($marginBottom);
    }

    /**
     * @return int
     */
    public function getMarginLeft()
    {
        return $this->margin->getLeft();
    }

    /**
     * @param int $marginLeft
     */
    public function setMarginLeft($marginLeft)
    {
        $this->margin->setLeft($marginLeft);
    }

    /**
     * @return array
     */
    public function getMargin()
    {
        return $this->margin->toArray();
    }
}