<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Generic;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;

trait StyleAwareTrait
{
    use BackgroundAwareTrait;
    use BorderAwareTrait;
    use DimensionAwareTrait;
    use MarginAwareTrait;
    use PaddingAwareTrait;
    use ShadowAwareTrait;

    /**
     * @var int
     * @ODM\Field(type="int")
     */
    protected $zIndex;

    /**
     * @var int
     * @ODM\Field(type="int")
     */
    protected $opacity;

    /**
     * @return int
     */
    public function getOpacity()
    {
        return $this->opacity;
    }

    /**
     * @param int $opacity
     * @return $this
     */
    public function setOpacity($opacity)
    {
        $this->opacity = $opacity;
        return $this;
    }

    /**
     * @return int
     */
    public function getZIndex()
    {
        return $this->zIndex;
    }

    /**
     * @param int $zIndex
     * @return $this
     */
    public function setZIndex($zIndex)
    {
        $this->zIndex = $zIndex;
        return $this;
    }
}