<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Research\Exposition\Weave\Iterator;

use FilterIterator;
use Iterator;
use Rc\Domain\Model\Research\Exposition\Weave\Tool\CommentTool;

class NoteFilterIterator extends FilterIterator
{

    /**
     * @var string
     */
    protected $noteFilter;

    /**
     * @param Iterator $iterator
     * @param string $noteFiler
     */
    public function __construct(Iterator $iterator, $noteFiler)
    {
        parent::__construct($iterator);

        $this->noteFilter = $noteFiler;
    }

    /**
     * @return bool
     */
    public function accept()
    {
        if (empty($this->noteFilter)) {
            return true;
        }

        $current = $this->current();
        if (!$current instanceof CommentTool) {
            return true;
        }

        if ($this->noteFilter == $current->getAuthor()->getId()) {
            return true;
        }

        if ($this->noteFilter == $current->getResolution()) {
            return true;
        }

        return false;
    }
}