<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Shape;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;

/**
 * @ODM\EmbeddedDocument
 */
class PlayerShape
{

    /**
     * @var boolean
     * @ODM\Field(type="boolean")
     */
    protected $loop;

    /**
     * @var boolean
     * @ODM\Field(type="boolean")
     */
    protected $autoPlay;

    /**
     * @var boolean
     * @ODM\Field(type="boolean")
     */
    protected $displayVolume = false;

    /**
     * @var boolean
     * @ODM\Field(type="boolean")
     */
    protected $displayMinimal;

    /**
     * @var boolean
     * @ODM\Field(type="boolean")
     */
    protected $hidePlayer;

    /**
     * @var boolean
     * @ODM\Field(type="boolean")
     */
    protected $stopOtherPlayers;

    /**
     * @return boolean
     */
    public function isLoop()
    {
        return $this->loop;
    }

    /**
     * @param boolean $loop
     */
    public function setLoop($loop)
    {
        $this->loop = $loop;
    }

    /**
     * @return boolean
     */
    public function isAutoPlay()
    {
        return $this->autoPlay;
    }

    /**
     * @param boolean $autoPlay
     */
    public function setAutoPlay($autoPlay)
    {
        $this->autoPlay = $autoPlay;
    }

    /**
     * @return boolean
     */
    public function isDisplayVolume()
    {
        return $this->displayVolume;
    }

    /**
     * @param boolean $displayVolume
     */
    public function setDisplayVolume($displayVolume)
    {
        $this->displayVolume = $displayVolume;
    }

    /**
     * @return boolean
     */
    public function isDisplayMinimal()
    {
        return $this->displayMinimal;
    }

    /**
     * @param boolean $displayMinimal
     */
    public function setDisplayMinimal($displayMinimal)
    {
        $this->displayMinimal = $displayMinimal;
    }

    /**
     * @return boolean
     */
    public function isHidePlayer()
    {
        return $this->hidePlayer;
    }

    /**
     * @param boolean $hide
     */
    public function setHidePlayer($hide)
    {
        $this->hidePlayer = $hide;
    }

    /**
     * @return boolean
     */
    public function isStopOtherPlayers()
    {
        return $this->stopOtherPlayers;
    }

    /**
     * @param boolean $stopOtherPlayers
     */
    public function setStopOtherPlayers($stopOtherPlayers)
    {
        $this->stopOtherPlayers = $stopOtherPlayers;
    }
}