<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Style;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\SimpleMedia\ImageSimpleMedia;

/**
 * @ODM\EmbeddedDocument
 */
class BackgroundStyle
{

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $color;

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $imageStyle;

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $imagePosition;

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $imageSize;

    /**
     * @var ImageSimpleMedia
     * @ODM\ReferenceOne(targetDocument="Rc\Domain\Model\Research\Exposition\SimpleMedia\ImageSimpleMedia", storeAs="dbRef")
     */
    protected $image;

    /**
     * @return string
     */
    public function getColor()
    {
        return $this->color;
    }

    /**
     * @param string $color
     * @return void
     */
    public function setColor($color)
    {
        $this->color = $color;
    }

    /**
     * @return string
     */
    public function getImageStyle()
    {
        return $this->imageStyle;
    }

    /**
     * @param string $imageStyle
     * @return void
     */
    public function setImageStyle($imageStyle)
    {
        $this->imageStyle = $imageStyle;
    }

    /**
     * @return string
     */
    public function getImagePosition()
    {
        return $this->imagePosition;
    }

    /**
     * @param string $imagePosition
     * @return void
     */
    public function setImagePosition($imagePosition)
    {
        $this->imagePosition = $imagePosition;
    }

    /**
     * @return string
     */
    public function getImageSize()
    {
        return $this->imageSize;
    }

    /**
     * @param string $imageSize
     * @return void
     */
    public function setImageSize($imageSize)
    {
        $this->imageSize = $imageSize;
    }

    /**
     * @return ImageSimpleMedia
     */
    public function getImage()
    {
        return $this->image;
    }

    /**
     * @param ImageSimpleMedia $image
     */
    public function setImage(ImageSimpleMedia $image = null)
    {
        $this->image = $image;
    }

    /**
     * @return bool
     */
    public function hasImage()
    {
        return isset($this->image);
    }

}