<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Research\Exposition\Weave;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Research\Exposition\Weave;

/**
 * @ODM\Document(collection="Weave")
 */
class TextWeave extends Weave
{
    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $markdown;

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $html;

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $style;

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $media;

    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $metadata;

    /**
     * @return string
     */
    public function getMarkdown()
    {
        return $this->markdown;
    }

    /**
     * @param string $markdown
     */
    public function setMarkdown($markdown)
    {
        $this->markdown = $markdown;
    }

    /**
     * @return string
     */
    public function getHtml()
    {
        return $this->html;
    }

    /**
     * @param string $html
     */
    public function setHtml($html)
    {
        $this->html = $html;
    }

    /**
     * @return string
     */
    public function getStyle()
    {
        return $this->style;
    }

    /**
     * @param string $style
     */
    public function setStyle($style)
    {
        $this->style = $style;
    }

    /**
     * @return string
     */
    public function getMedia()
    {
        return $this->media;
    }

    /**
     * @param string $media
     */
    public function setMedia($media)
    {
        $this->media = $media;
    }

    /**
     * @return string
     */
    public function getMetadata()
    {
        return $this->metadata;
    }

    /**
     * @param string $metadata
     */
    public function setMetadata($metadata)
    {
        $this->metadata = $metadata;
    }

    /**
     * @return void
     */
    public function removeExternalDependencies()
    {
        //
    }
}