<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Tool;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Media\MediaType;
use Rc\Domain\Model\Research\Exposition\Weave\Shape\PlayerShape;
use Rc\Domain\Model\Research\Exposition\Weave\Tool;
use Rc\Domain\Model\Research\Exposition\Weave\Tool\Generic\PlayerAwareInterface;
use Rc\Domain\Model\Research\Exposition\Weave\Tool\Generic\PlayerAwareTrait;

/**
 * @ODM\Document
 */
class AudioTool extends Tool implements PlayerAwareInterface
{
    use PlayerAwareTrait;

    public function __construct()
    {
        parent::__construct();
        $this->player = new PlayerShape();
    }

    /**
     * @return array
     */
    public function getSupportedMediaTypes()
    {
        return [
            MediaType::AUDIO,
        ];
    }
}