<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Research\Exposition\Weave\Tool\Context;

use Rc\Domain\Model\Research\Application;
use Rc\Domain\Repository\Research\ApplicationRepository;

class ContextRegistry
{

    /**
     * @var array
     */
    protected static $context = [];

    /**
     * @param Application|null $application
     */
    public static function applyContext(Application $application = null)
    {
        self::$context = [
            'application' => $application,
        ];
    }

    /**
     * @param string $key
     * @return bool
     */
    public static function hasContextFor($key)
    {
        return isset(self::$context[$key]);
    }

    /**
     * @return array
     */
    public static function getContext()
    {
        return self::$context;
    }

    /**
     * @return void
     */
    public static function fromGlobals()
    {
        if (isset($_REQUEST['application']) && $_REQUEST['application'] != '') {
            $application = ApplicationRepository::getById($_REQUEST['application']);
        } else {
            $application = null;
        }

        self::applyContext($application);
    }
}