<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Tool\Generic;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;

interface ScrollbarAwareInterface
{
    const SCROLLBAR_VISIBILITY_AUTO = 'scrollbar-auto';
    const SCROLLBAR_VISIBILITY_ONMOUSEOVER = 'scrollbar-onmouseover';
    const SCROLLBAR_VISIBILITY_ALWAYS = 'scrollbar-always';
    const SCROLLBAR_VISIBILITY_NEVER = 'scrollbar-never';

    /**
     * @return array
     */
    public static function getScrollbarVisibilities();

    /**
     * @return string
     */
    public function getScrollbarVisibility();

    /**
     * @param string $scrollbarVisibility
     */
    public function setScrollbarVisibility($scrollbarVisibility);
}