<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Tool\Generic;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;

trait ScrollbarAwareTrait
{
    /**
     * @var string
     * @ODM\Field(type="string")
     */
    protected $scrollbarVisibility;

    /**
     * @return array
     */
    public static function getScrollbarVisibilities()
    {
        return [
            ScrollbarAwareInterface::SCROLLBAR_VISIBILITY_AUTO        => 'srollbar.visibility.auto',
            ScrollbarAwareInterface::SCROLLBAR_VISIBILITY_ONMOUSEOVER => 'srollbar.visibility.onmouseover',
            ScrollbarAwareInterface::SCROLLBAR_VISIBILITY_ALWAYS      => 'srollbar.visibility.always',
            ScrollbarAwareInterface::SCROLLBAR_VISIBILITY_NEVER       => 'srollbar.visibility.never',
        ];
    }

    /**
     * @return string
     */
    public function getScrollbarVisibility()
    {
        return $this->scrollbarVisibility;
    }

    /**
     * @param string $scrollbarVisibility
     */
    public function setScrollbarVisibility($scrollbarVisibility)
    {
        $this->scrollbarVisibility = (string)$scrollbarVisibility;
    }
}