<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Tool;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Media\MediaType;
use Rc\Domain\Model\Research\Exposition\Weave\Tool;

/**
 * @ODM\Document
 */
class PdfTool extends Tool
{
    /**
     * @var boolean
     * @ODM\Field(type="boolean")
     */
    protected $displayInBrowser;

    /**
     * @return array
     */
    public function getSupportedMediaTypes()
    {
        return [
            MediaType::PDF,
        ];
    }

    /**
     * @return boolean
     */
    public function isDisplayInBrowser()
    {
        return $this->displayInBrowser;
    }

    /**
     * @param boolean $displayInBrowser
     */
    public function setDisplayInBrowser($displayInBrowser)
    {
        $this->displayInBrowser = $displayInBrowser;
    }
}