<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research\Exposition\Weave\Tool;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Media\MediaType;
use Rc\Domain\Model\Research\Exposition\Generic\TextAwareInterface;
use Rc\Domain\Model\Research\Exposition\Weave\Tool;
use Rc\Domain\Model\Research\Exposition\Weave\Tool\Generic\ScrollbarAwareInterface;
use Rc\Domain\Model\Research\Exposition\Weave\Tool\Generic\ScrollbarAwareTrait;

/**
 * @ODM\Document
 */
class SimpletextTool extends Tool implements ScrollbarAwareInterface, TextAwareInterface
{
    use ScrollbarAwareTrait;

    /**
     * @return array
     */
    public function getSupportedMediaTypes()
    {
        return [
            MediaType::TEXT,
        ];
    }
}