<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research;

use Doctrine\ODM\MongoDB\Mapping\Annotations as ODM;
use Rc\Domain\Model\Media\MediaAwareInterface;
use Rc\Domain\Model\Media\Resource\ImageResource;

interface MediaContainerInterface extends MediaAwareInterface
{

    /**
     * @return int
     */
    public function getId();

    /**
     * @param int $id
     */
    public function setId($id);

    /**
     * @return string
     */
    public function getName();

    /**
     * @param string $name
     */
    public function setName($name);

    /**
     * @return ImageResource|null
     */
    public function getThumb();

    /**
     * @return bool
     */
    public function isImage();

    /**
     * @return bool
     */
    public function isVideo();

    /**
     * @return bool
     */
    public function isAudio();

    /**
     * @return bool
     */
    public function isPdf();

    /**
     * @return bool
     */
    public function isArchive();

    /**
     * @return string
     */
    public function getContentType();

    /**
     * @param string $contentType
     */
    public function setContentType($contentType);

    /**
     * @return string
     */
    public function getMimeType();

    /**
     * @return bool
     */
    public function isEmpty();

}