<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Research;

use Rc\Domain\Model\ObjectShare;
use Rc\Domain\Model\Research;
use Rc\Domain\Repository\ObjectShareRepository;

/**
 * @mixin Research
 */
trait ObjectShareAwareTrait
{
    /**
     * @param bool $flag
     */
    public function setObjectShare(bool $flag)
    {
        $objectShare = ObjectShareRepository::findByEntity($this);

        if ($flag && !isset($objectShare)) {
            $objectShare = new ObjectShare();
            $objectShare->setEntity($this);
            ObjectShareRepository::persist($objectShare);
        } elseif (!$flag && isset($objectShare)) {
            ObjectShareRepository::remove($objectShare);
        }
    }

    /**
     * @return boolean
     */
    public function getObjectShare()
    {
        return (bool)ObjectShareRepository::findByEntity($this);
    }

}
