<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Model\Research;

use Rc\Domain\Model\Research\Exposition\SimpleMediaInterface;

interface SimpleMediaAwareInterface
{
    /**
     * @return boolean
     */
    public function hasThumb();

    /**
     * @return SimpleMediaInterface|null
     */
    public function getThumb();

    /**
     * @param SimpleMediaInterface|null $thumb
     */
    public function setThumb(SimpleMediaInterface $thumb = null);

    /**
     * @return boolean
     */
    public function hasMedia();

    /**
     * @return SimpleMediaInterface|null
     */
    public function getMedia();

    /**
     * @return SimpleMediaInterface[]
     */
    public function getMediaList();

    /**
     * @param array $mediaList
     */
    public function setMediaList(array $mediaList);

    /**
     * @param SimpleMediaInterface|null $media
     */
    public function setMedia(SimpleMediaInterface $media = null);

    /**
     * @return SimpleMediaInterface[]
     * @deprecated
     */
    public function getResources();

    /**
     * @param SimpleMediaInterface[] $resources
     * @deprecated
     */
    public function setResources(array $resources);

    /**
     * @return bool
     * @deprecated
     */
    public function hasResources();

    /**
     * @return int
     * @deprecated
     */
    public function getResourceCount();

    /**
     * @param SimpleMediaInterface $simpleMedia
     * @deprecated
     */
    public function addResource(SimpleMediaInterface $simpleMedia);

    /**
     * @param SimpleMediaInterface $resource
     * @deprecated
     */
    public function removeResource(SimpleMediaInterface $resource);

    /**
     * @return array
     * @deprecated
     */
    public function getResourceIds();

    /**
     * @param int $resourceId
     * @deprecated
     */
    public function removeResourceId($resourceId);

    /**
     * @return $this
     * @deprecated
     */
    public function clearMediaList();

    /**
     * @return SimpleMediaInterface|null
     * @deprecated
     */
    public function getFirstResource();
}