<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Model\Research;

interface StatusAwareInterface
{

    const STATUS_PROGRESS = 'progress';
    const STATUS_REVIEW = 'review';
    const STATUS_PUBLISHED = 'published';
    const STATUS_REVIEW_PUBLISHED = 'republish';
    const STATUS_DECLINED = 'declined';
    const STATUS_PRE_REVIEW = 'pre-review';
    const STATUS_REWORK = 'rework';

    /**
     * @return string
     */
    public function getStatus();

    /**
     * @todo
     * @param string $status
     */
    public function setStatus($status);

    /**
     * @internal
     * @param string $value
     */
    public function setStatusValue($value);

    /**
     * @param string $status
     * @return bool
     */
    public function isStatus($status);

    /**
     * @return bool
     */
    public function isPublished();

    /**
     * @return bool
     */
    public function isInReview();

    /**
     * @return bool
     */
    public function isInProgress();

    /**
     * @return void
     */
    public function removeExternalDependencies();
}
