<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Repository\Application;

use Rc\Domain\Model\Application\ApplicationFavorite;
use Rc\Domain\Model\Application\ApplicationProgram;
use Rc\Domain\Repository\MongoRepository;

/**
 * @method static ApplicationFavorite findById($id)
 */
class ApplicationFavoriteRepository extends MongoRepository
{

    /**
     * @param ApplicationProgram $program
     * @param array $options
     * @return ApplicationFavorite[]
     */
    public static function findByProgram(ApplicationProgram $program, array $options = [])
    {
        $options['sort'] = ['created' => self::SORT_DESC];

        return self::find([
            'program.uuid' => (string)$program->getUuid(),
        ], $options);
    }

    /**
     * @param string $field
     * @return bool
     */
    protected static function isMultiLanguageField($field)
    {
        return false;
    }
}