<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Repository\Generic;

use Rc\Domain\Model\AbstractModel;

class Suggest
{
    /**
     * @var string
     */
    protected $match;

    /**
     * @var AbstractModel
     */
    protected $entity;

    /**
     * @param string $match
     * @param AbstractModel $entity
     */
    public function __construct($match, AbstractModel $entity)
    {
        $this->match = (string)$match;
        $this->entity = $entity;
    }

    /**
     * @return int
     */
    public function getEntityId()
    {
        return $this->entity->getId();
    }

    /**
     * @return AbstractModel
     */
    public function getEntity()
    {
        return $this->entity;
    }

    /**
     * @return string
     */
    public function getMatch()
    {
        return $this->match;
    }
}
