<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */
namespace Rc\Domain\Repository\Media;

use Rc\Domain\Model\Media\Resource as MediaResource;
use Rc\Domain\Repository\MediaRepository;
use Rc\Domain\Repository\MongoRepository;

/**
 * @method static MediaResource|null findById($id)
 * @method static MediaResource getById($id)
 * @method static MediaResource[] findByIds(array $id, array $options = [])
 * @method static MediaResource[] findAll(array $options = [])
 */
class ResourceRepository extends MongoRepository
{

    /**
     * @param string $checkSum
     * @return MediaResource|null
     */
    public static function findByCheckSum($checkSum)
    {
        $media = MediaRepository::findByCheckSum($checkSum);
        if (!isset($media)) {
            return null;
        }

        foreach ($media->getResourceList() as $resource) {
            if ($resource->getCheckSum() == $checkSum) {
                return $resource;
            }
        }

        return null;
    }

}