<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Domain\Repository\Research\Exposition;

use Rc\Domain\Model\Research\Exposition;
use Rc\Domain\Model\Research\Exposition\ToolTemplate;
use Rc\Domain\Repository\MongoRepository;

/**
 * @method static ToolTemplate|null findById($id)
 * @method static ToolTemplate getById($id)
 * @method static ToolTemplate[] findByIds(array $id, array $options = [])
 * @method static ToolTemplate[] findAll(array $options = [])
 */
class ToolTemplateRepository extends MongoRepository
{
    /**
     * @param string $tool
     * @param Exposition $exposition
     * @param array $options
     * @return ToolTemplate
     */
    public static function findByNameAndResearch($tool, Exposition $exposition, array $options = [])
    {
        return self::findOne([
            'exposition.uuid' => (string)$exposition->getUuid(),
            'tool._class'     => \ToolFactory::getObjectName($tool),
        ], $options);
    }
}