<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Utility;

class Arrays
{
    /**
     * @param string $input
     * @param string $delimiter
     * @param bool $onlyNonEmptyValues
     * @return array
     */
    public static function trimExplode($input, $delimiter, $onlyNonEmptyValues = false)
    {
        $chunks = explode($delimiter, $input);

        return array_map(function ($value) use ($onlyNonEmptyValues) {
            if ($onlyNonEmptyValues && trim($value) === '') {
                return $value;
            }
            return trim($value);
        }, $chunks);
    }
}