<?php
/**
 * Copyright (c) 2018 by Society for Artistic Research
 *
 * All rights reserved.
 *
 * Modification, distribution, commercial or non-commercial reuse is prohibited without explicit written permission by the copyright holder.
 */

namespace Rc\Utility;

use Rc\Domain\Model\Research\Exposition\Popover;
use Rc\Domain\Repository\Research\Exposition\Weave\ToolRepository;

class PopoverHelper
{
    /**
     * @param Popover $popover
     * @return bool
     */
    public static function toolExists(Popover $popover)
    {
        if (!$popover->hasTool()) {
            return true;
        }

        $tool = ToolRepository::findById($popover->getTool()->getUuid());
        if (!isset($tool)) {
            return false;
        }

        return true;
    }
}